/**
 * Created by EX-ZHANGYANJUN002 on 15-8-27.
 */
define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .withdraw': 'goWithdraw'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.ACCOUNT_BALANCE,
                leftCallback:function(){
                    C.Native.back();
                }
            });
            C.UI.loading();
            C.Native.getYiQianBaoBalance(function (res) {
                C.UI.stopLoading();
                if (C.Flag.SUCCESS == res.flag) {
                    self.render(res.data);
                } else {                        
                    C.Native.tip(res.msg);
                }
            });
        },
        // 渲染整个view
        render: function (data) {
            $('.money').html((data.mainBalance || '0'));
            if (!!parseInt(data.mainBalance)) {
                $('.withdraw').removeClass('btn-biggerG').addClass('btn-bigger');
            }
        },
        goWithdraw: function () {
            C.Native.jumpToYiQianBao();
        }
    }));

    $(function() {
        new Page();
        $$.EventListener.pageDidAppear = function () {
            C.Native.getUserInfo(function(data){
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                location.reload();
            });
        }
    });
});