define(['zepto', 'C', 'view', 'js/component/identity','js/iloan'], function ($, C, View, Identity, L) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .total-money-tap': 'goTotalMoney',
            'tap .bankcard-li-tap': 'goBankcard',
            'tap .score-li-tap': 'goScore',
            'tap .balance-li-tap': 'goBalance',
            'tap .borrow-div-tap': 'goBorrowPage',
            'tap .profit-div-tap': 'goHQB',
            'tap .repay-rightnow': 'goRepaymentList',
            'tap .loan-rightnow': 'goProducts',
            'tap .loan-another': 'goTopup',
            'tap .xbyd,.fdyd': 'goXindai',
            'tap .need-identity': 'needIdentity',
            'tap .no-papay': 'goBindPapay',
            'tap .apply-rate': 'goApplyRate',
            'tap .zed-more': 'goZedApplyRecord',
            'tap .zhaiedai': 'goZhai',
            'tap .add-loan-go': 'goAddLoan',
            'tap .add-loan-know': 'knowAddLoan',
            'tap .idai' : 'goIloan',
            'tap .czd,.sxd': 'goCarLife'
        },
        // 实例化后默认初始化该方法
        initialize: function () {


            C.UI.loading();
            var self = this;
            /*
             *防重复点击变量
             */
            self.refuseDoubleClick = false;
            /*
             *判断是否跳转外部浏览器变量
             */
            self.isToBrowse = '';
            //初始化需7个请求
            self.steps = 7;
            //各借款分类的数量
            self.apCount = self.fpCount = self.rpCount = self.odCount = 0;
            //只有一个申请状态或者只有一个立即还款状态的借款时保存产品名
            self.apProduction = self.rpodProduction = '';
            //设置标题
            C.Native.setHeader({
                title: C.Constant.TITLE.MY_ACCOUNT
            });
	    //获取城市信息
            self.cityName = C.Utils.data(C.Constant.DataKey.CITY_NAME);
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            self.deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO);
            /*
             *是否有追加贷款资格;N没有Y有
             */
            self.addLoan = 'N';

            C.Utils.data(C.Constant.DataKey.HOME_BORROW_MONEY, '');
            C.Utils.data(C.Constant.DataKey.HOME_WX_BORROW_MONEY, '');
            C.Utils.data(C.Constant.DataKey.HOME_XB_BORROW_MONEY, '');
            C.Utils.data(C.Constant.DataKey.HOME_ZED_BORROW_MONEY, '');

            C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    //判断是否已补录身份信息
                    if (!!self.userInfo.custId) {
                        //判断是否绑定平安付
                        if (!!self.userInfo.paPayToken) {

                            //获取用户总资产及余额
                            C.Native.getYiQianBaoBalance(function (res) {
                                if (C.Flag.SUCCESS == res.flag) {
                                    self.balanceShow(res.data);
                                }
                            });
                        } else {
                            $('.total-money,.my-borrow-nologin').hide();
                            $('.no-papay').show();
                        }
                        self.getData();
                    } else {
                        self.steps = self.steps - 7;
                        self.stopLoading();
                        $('.total-money,.no-papay').hide();
                        $('.my-borrow-nologin').show();
                    }
                } else {
                    self.steps = self.steps - 7;
                    self.stopLoading();
                    C.Native.tip('尚未登录');
                }
            });
        },
        // 渲染整个view
        render: function (obj) {
            $('.borrow-div').addClass('borrow-div-tap');
            //把我的借款金额加入到累计借款总额中
            if(obj.totalMoney) {
                var currentMoney = parseFloat($('.borrow-val').text().replace(/,/g, '')) || 0;            
                $('.borrow-val').html(C.Utils.formatMoney(currentMoney + obj.totalMoney, 2));
            }
            //我的借款列表中显示我的借款

            var html = _.template($("#my-borrow-tpl").html())({list: obj.borrowList});
            $('.borrow-pro .my-borrow-empty').hide();
            $('.borrow-list').show().append(html);
            $('.list-account').show();
            if(this.odCount > 0){
            	$('.icon-mast').html('<span class="red-dot"></span>');
            }
        },
	    showWXdata: function (obj) {
            $('.borrow-div').addClass('borrow-div-tap');
            //把我的借款金额加入到累计借款总额中
            if(obj.totalMoney) {
                var currentMoney = parseFloat($('.borrow-val').text().replace(/,/g, '')) || 0;            
                $('.borrow-val').html(C.Utils.formatMoney(currentMoney + obj.totalMoney, 2));
            }
            //我的借款列表中显示我的借款
            var html = _.template($("#wx-borrow-tpl").html())({list: obj.borrowList});
            $('.borrow-pro .my-borrow-empty').hide();
            $('.borrow-list').show().append(html);
            //
            $('.list-account').show();
            if(this.odCount > 0){
                $('.icon-mast').html('<span class="red-dot"></span>');
            }
        },
        stopLoading: function () {
            this.steps--;
            if (this.steps <= 0) {
                C.UI.stopLoading();
            }
        },
        getData: function () {
            $('.borrow-pro .borrow-list, .list-account').hide();
            $('.borrow-pro .borrow-list').html('');
            $('.borrow-pro .my-borrow-empty').show();
            $('.borrow-val').html('-');

            var self = this;
            // 获取积分
            self.getScore();
            //获取用户贷款信息
            $.ajax({
                type: "get",
                url: C.Api.QUERY_USERAPPLY_STATE,
                data: {
                    cityName: self.cityName
                },
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    if (C.Flag.SUCCESS == res.flag) {
                        //保存供申请进度和立即还款使用
                        C.Utils.data(C.Constant.DataKey.HOME_WX_BORROW_MONEY, res.data);
                        self.getWXData(res.data);
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            // 获取信保信息
            $.ajax({
                type: "get",
                url: C.Api.QUERY_XBLOAN_INFO,
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    if (C.Flag.SUCCESS == res.flag) {
                        //保存供申请进度和立即还款使用
                        C.Utils.data(C.Constant.DataKey.HOME_XB_BORROW_MONEY, res.data);
                        self.getXBFDData(res.data);
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //获取银行卡数量
            $.ajax({
                type: "get",
                url: C.Api.BANK_CARD,
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    if (C.Flag.SUCCESS == res.flag) {
                        var cards = res.data.bindCardList ? res.data.bindCardList.length : 0;
                        $('.bankcard-val').html(cards);
                        $('.bankcard-li').addClass('bankcard-li-tap');
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });
            //获取宅e贷借款数据
            var identifyId = self.userInfo.Id || self.userInfo.id,
                endDecVer = '1.0.0';
            identifyId = C.rsaEncrypt(identifyId);
            $.ajax({
                type: "get",
                url: C.Api.QUERY_ZED_APPLY_RECORD,
                data: {
                    certId: identifyId || "",
                    clientNo: self.userInfo.accountId,
                    clientModel: "YD",
                    endDecVer: endDecVer
                },
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    if (res && res.flag == C.Flag.SUCCESS) {
                        if (res.data && res.data.applyMap) {
                            //保存供申请进度和立即还款使用
                            C.Utils.data(C.Constant.DataKey.HOME_ZED_BORROW_MONEY, res.data.applyMap);
                            self.getZedData(res.data.applyMap);
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            $('.icon-moreone').html('');
            //检测是否有追加贷款资格
            $.ajax({
                type: "get",
                url: C.Api.QUERY_ADD_LOAN_QUAL,
                success: function (res) {
                    self.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        if (res.data && res.data.isTopup == 'Y' && res.data.hasQualification == 'Y') {
                            var data = res.data;
                            //是否有追加贷款资格
                            self.addLoan = 'Y';
                            //是否显示提示框信息
                            if (data.showTip == 'Y' && data.topupProgress == 0) {
                                var obj = {
                                    name : self.userInfo.custName,
                                    money : (data.isCreditCust == 'Y' && data.creditLine > 0)?data.creditLine:0
                                };
                                var html = _.template($("#topup-tpl").html())(obj);
                                $('.add-loan-sec').html(html).show();
                            }
                            //是否显示追加贷款小红点
                            if (data.topupProgress == 0) {
                                $('.icon-moreone').html('<span class="red-dot"></span>');
                            }
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //获取车寿借款数据
            $.ajax({
                type: "get",
                url: C.Api.HOME_CAR_LIFE,
                data: {machineSN : self.deviceInfo.MachineSN},
                success: function (res) {
                    self.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        //保存供申请进度和立即还款使用
                        C.Utils.data(C.Constant.DataKey.ACCOUNT_CAR_LIFE, res.data);
                        self.getCarLifeData(res.data);
                        if (res.data.isCheShou == '0' && res.data.applStatus == '0'){
                            self.isToBrowse = '1';
                        } else {
                            self.isToBrowse = '0';
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            // 获取积分
            // self.getScore();
        },
        //获取积分数
        getScore: function () {
            var self = this;
            if (self.userInfo.pointsSwitch == 'Y') {
                $('#score-content').show();
                $.ajax({
                    type: "post",
                    url: C.Api.MY_SCORE,
                    success: function (res) {
                        self.stopLoading();
                        if (C.Flag.SUCCESS == res.flag) {
                            var totalPoints = res.data.totalPoints || '-';
                            $('.score-li').addClass('score-li-tap');
                            $('.score-val').html(totalPoints);
                        }
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            } else {
                self.stopLoading();
            }
        },
        getZedData: function (applyMap) {
            var self = this;
            var obj = {
                length: 1,
                productId: 'zed-more',
                iconClass: C.Constant.ICON.zhaiedai,
                productName: '宅e贷',
                productStatus: '有抵押',
                totalBalanceMoney: 0
            };

            var applyList = C.operZedData(applyMap);
            var apCountFlag = 0, rpCountFlag = 0, odCountFlag = 0;
            //检测其中申请中和需还款的借款
            for (var i = 0; i < applyList.length; i++) {
                if ($.inArray(applyList[i].statusCode, [8, 10, 12]) > -1) {
                    //属于立即还款状态
                    self.rpodProduction = (!self.rpCount && !self.odCount) ? 'zed' : '';
                    if(applyList[i].statusCode == 8) {
                        rpCountFlag = 1;
                    }
                    if(applyList[i].statusCode == 12) {
                        odCountFlag = 1;
                    }
                } else if ($.inArray(applyList[i].statusCode, [1, 2, 3, 4, 6, 7]) > -1) {
                    //属于申请状态
                    apCountFlag = 1;
                    self.apProduction = (self.apCount == 0) ? 'zed' : '';
                }
                //总借款
                obj.totalBalanceMoney += applyList[i].balanceMoney;
            }
            self.apCount += apCountFlag;
            self.rpCount += rpCountFlag;
            self.odCount += odCountFlag;

            if (applyList.length == 1) {
                var data = applyList[0];
                if (data.statusCode) {
                    obj.statusCode = data.statusCode;
                    obj.statusName = data.statusName;
                    obj.money = data.money;
                    obj.moneyText = data.moneyText;
                    self.showZedData(obj);
                }
            } else if (applyList.length > 1) {
                obj.productId = 'zed-more';
                obj.productText = "您当前有多笔借款";
                obj.length = applyList.length;
                if(odCountFlag > 0) {
                    obj.productText = "您当前有多笔借款（有逾期）";
                }
                self.showZedData(obj);
            }
        },
        getXBFDData: function (data) {
            var self = this;
            var obj = C.operXBFDBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'FP') {
                    self.fpCount++;
                    return false;
                } else {
                    if (item.status == 'AP') {
                        self.apProduction = !self.apCount ? 'xbfd' : '';
                        self.apCount++;
                    } else if (item.status == 'RP') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'xbfd' : '';
                        self.rpCount++;
                    } else if (item.status == 'OD') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'xbfd' : '';
                        self.odCount++;
                    }
                    return true;
                }
            });

            if (self.apCount || self.rpCount || self.odCount || self.fpCount) {
                self.render(obj);
            }
        },

        getWXData: function (data) {
            var self = this;
            var obj = C.operWXBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'SE') {
                    self.fpCount++;
                    return false;
                } else {
                    if (item.status == 'AP') {
                        self.apProduction = !self.apCount ? 'idai' : '';
                        self.apCount++;
                    } else if (item.status == 'RP') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'idai' : '';
                        self.rpCount++;
                    } else if (item.status == 'OD') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'idai' : '';
                        self.odCount++;
                    }
                    return true;
                }
            });

            if (self.apCount || self.rpCount || self.odCount || self.fpCount) {
                self.showWXdata(obj);
            }
        },
        getBorrowData: function (data) {
            var self = this;
            var obj = C.operBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'FP') {
                    self.fpCount++;
                    return false;
                } else {
                    if (item.status == 'AP') {
                        self.apProduction = !self.apCount ? 'idai' : '';
                        self.apCount++;
                    } else if (item.status == 'RP') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'idai' : '';
                        self.rpCount++;
                    } else if (item.status == 'OD') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'idai' : '';
                        self.odCount++;
                    }
                    return true;
                }
            });
            var wxapIndex = -1;
            for (var i = 0; i < obj.borrowList.length; i++) {
                if (obj.borrowList[i].productId == 'idai' && obj.borrowList[i].status == 'AP') {
                    //标记i贷的申请状态，用于重新请求获取状态值
                    wxapIndex = i;
                }
            }

            //对于网销申请状态,请求searchAppInfo接口确定更详细状态
            if (wxapIndex > -1) {
                var userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
                var deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO);
                var merReserved = C.Utils.data(C.Constant.DataKey.DEVICE_MER_RESERVED);
                var cityName = C.Utils.data(C.Constant.DataKey.CITY_NAME);
                $.ajax({
                    type: "get",
                    url: C.Api.SEARCH_APPL_INFO,
                    data: {
                        accountId: userInfo.accountId || '',
                        longitude: deviceInfo.longitude || '',
                        latitude: deviceInfo.latitude || '',
                        merReserved: JSON.stringify(merReserved) || '',
                        cityName: cityName || ''
                    },
                    success: function (res) {
                        if (res && res.flag == C.Flag.SUCCESS && res.data) {
                            if (res.data.mark == 'BE') {
                                obj.borrowList[wxapIndex].moneyStatus = '申请中';
                            } else if (res.data.mark == 'BN') {
                                obj.borrowList[wxapIndex].moneyStatus = '已申请';
                            }
                        }
                        if (self.apCount || self.rpCount || self.odCount || self.fpCount) {
                            self.render(obj);
                        }
                        C.UI.stopLoading();
                    },
                    error: function () {
                        if (self.apCount || self.rpCount || self.odCount || self.fpCount) {
                            self.render(obj);
                        }
                        C.UI.stopLoading();
                    }
                });
            } else {
                if (self.apCount || self.rpCount || self.odCount || self.fpCount) {
                    self.render(obj);
                }
                C.UI.stopLoading();
            }

        },
        getCarLifeData: function (data) {
            var self = this;
            var obj = C.operCarLifeData(data);
            
            obj.carlifeList = obj.carlifeList.filter(function (item) {
                if (item.productId == "czd") {
                    if (item.applStatus == '0') {
                        self.apProduction = !self.apCount ? 'czd' : '';
                        self.apCount++;
                    } else if (item.applStatus == '3') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'czd' : '';
                        self.rpCount++;
                    }
                    return true;
                } else if (item.productId == "sxd") {
                    if (item.applStatus == '0') {
                        self.apProduction = !self.apCount ? 'sxd' : '';
                        self.apCount++;
                    } else if (item.applStatus == '3') {
                        self.rpodProduction = (!self.rpCount && !self.odCount) ? 'sxd' : '';
                        self.rpCount++;
                    }
                    return true;
                }
            });
            self.showCarLifeData(obj);
        },
        showZedData: function (obj) {
            //把宅e贷借款金额加入到累计借款金额中
            if(obj.totalBalanceMoney) {
                var currentMoney = parseFloat($('.borrow-val').text().replace(/,/g, '')) || 0;            
                $('.borrow-val').html(C.Utils.formatMoney(currentMoney + obj.totalBalanceMoney, 2));
            }
            //我的借款列表中显示宅e贷借款
            var html = _.template($("#zed-content-tpl").html())(obj);
            $('.borrow-pro .my-borrow-empty').hide();
            $('.borrow-list').show().append(html);
            //
            $('.list-account').show();
            if(this.odCount > 0){
                $('.icon-mast').html('<span class="red-dot"></span>');
            }
        },

        //渲染车寿数据信息
        showCarLifeData: function (obj) {
            //把车寿借款金额加入到累计借款金额中
            /*if(obj.totalMoney) {
                var currentMoney = parseFloat($('.borrow-val').text().replace(/,/g, '')) || 0;            
                $('.borrow-val').html(C.Utils.formatMoney(currentMoney + obj.totalMoney, 2));
            }*/
            //我的借款列表中显示我的借款
            var html = _.template($("#my-carlife-tpl").html())({list: obj.carlifeList});
            $('.borrow-pro .my-borrow-empty').hide();
            $('.borrow-list').show().append(html);
            
            $('.list-account').show();
            if(this.odCount > 0){
                $('.icon-mast').html('<span class="red-dot"></span>');
            }
        },

        //显示总资产和余额
        balanceShow: function (data) {
            var mainBalance = parseFloat(data.mainBalance.replace(/,/g, '')),
                hqBaoBalance = parseFloat(data.hqBaoBalance.replace(/,/g, '')),
                totalMoney = mainBalance + hqBaoBalance;
            totalMoney = C.Utils.formatMoney(totalMoney, 2);

            $('.my-borrow-nologin,.no-papay').hide();

            $('.total-money').addClass('total-money-tap').show();
            $('.total-money .monney').html(totalMoney);
            $('.balance-li').addClass('balance-li-tap');
            $('.balance-li .balance-val').html(mainBalance);
            $('.profit-div').addClass('profit-div-tap');
        },
        goTopup: function () {
            var self = this;
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0708
            });
            if (self.apCount && !self.rpCount && !self.odCount && !self.fpCount) {
                C.Native.tip('暂无资格');
            } else {
                self.checkTopup();
            }
        },
        goAddLoan: function () {
            $('.add-loan-sec').hide();
            C.Native.getAppVersion(function (res) {
                if (res.version >= 420) {
                    L.goXindai();
                } else {
                    C.Native.gotoNative('iLoan');
                }
            });
        },
        knowAddLoan: function () {
            $('.add-loan-sec').hide();
            $.ajax({
                type: "get",
                url: C.Api.MESSAGE_NOT_TO_REMIND,
                success: function (res) {
                },
                error: function (res) {
                    console.log(arguments);
                }
            });
        },
        checkTopup: function () {
            var self = this;
            if (self.addLoan == 'Y') {
                window.needRefresh = true;
                L.goXindai(1);
            } else {
                C.Native.tip('暂时无法申请追加，请按时还款、累计信用，下次再试');
            }
        },
        goTotalMoney: function () {
            C.Native.forward({
                url: 'assets.html'
            });
        },
        goRepaymentList: function () {
            var self = this;
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0709
            });

            if (self.rpCount + self.odCount > 1) {
                C.Native.forward({
                    url: 'repayment-list.html'
                });
            } else if (self.rpCount + self.odCount == 1) {
                if (self.rpodProduction == 'idai') {
                    L.goIloan();
                } else if (self.rpodProduction == 'zed') {
                    window.needRefresh = true;
                    C.Native.forwardModule({
                        module: 'zed',
                        url: 'apply_record.html'
                    });
                } else if (self.rpodProduction == 'xbfd') {
                    L.goXindai();
                }
            } else {
                C.Native.tip('暂无可还款贷款');
            }
        },
        goApplyRate: function () {
            var self = this;
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0710
            });

            if (self.apCount > 1) {
                C.Native.forward({
                    url: 'apply-rate.html'
                });
            } else if (self.apCount == 1) {
                if (self.apProduction == 'idai') {
                     L.goIloan();
                } else if (self.apProduction == 'zed') {
                    window.needRefresh = true;
                    C.Native.forwardModule({
                        module: 'zed',
                        url: 'apply_record.html'
                    });
                } else if (self.apProduction == 'xbfd') {
                    L.goXindai();
                }
            } else {
                C.Native.tip('暂无申请中贷款');
            }
        },
        goProducts: function () {
            var self = this;
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            if (!!self.userInfo.custId) {
                C.Native.forward({
                    url: 'products.html'
                });                        
            }
            else{
                var identity = new Identity({model: {callback: $$.EventListener.onRefresh}});
                $('body').append(identity.el);
                C.UI.stopLoading();
            }
        },
        goBankcard: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0704
            });
            C.Native.forward({
                url: 'bank-card.html'
            });
        },
        goScore: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0705
            });
            C.Native.forward({
                url: 'my-score.html'
            });
        },
        goBalance: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0706
            });
            C.Native.forward({
                url: 'account-balance.html'
            });
        },
        goBorrowPage: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0702
            });
            C.Native.forward({
                url: 'borrow-money.html'
            });
        },
        goToiLoan: function () {
            window.needRefresh = true;
            C.Native.gotoNative('iLoan');
        },
        needIdentity: function () {
            var identity = new Identity({model: {callback: $$.EventListener.onRefresh}});
            $('body').append(identity.el);
        },
        goBindPapay: function () {
            C.Native.loginOrRegistPaOne(function () {
                $$.EventListener.onRefresh();
            });
        },
        goHQB: function () {
            var self = this;
            if (!!self.userInfo.paPayToken) {
                C.Native.updatePapayToken(self.userInfo.paPayToken, function (data) {
                    self.userInfo.paPayToken = data.paPayToken;
                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, self.userInfo);
                    //埋点
                    C.Native.TDOnEvent({
                        eventId: C.TD.Event.MY_ACCOUNT_0703
                    });
                    C.Native.forward({
                        url: C.Constant.PAPAY_HQB_PAGE,
                        data: {access_token: self.userInfo.paPayToken}
                    });
                });

            } else {
                C.Native.loginOrRegistPaOne(function () {
                    $$.EventListener.onRefresh();
                });
            }
        },
        goZedApplyRecord: function () {
            window.needRefresh = true;
            C.Native.forwardModule({
                module: 'zed',
                url: 'apply_record.html'
            });
        },
        goZhai: function () {
            window.needRefresh = true;
            C.Native.forwardModule({
                module: 'zed',
                url: 'index_z_apply.html'
            });
        },
        
        //----------------------iloan new
        /**
         * 清除iloan模块缓存数据
         * */
        clearIloanData: function() {
        	var keyjson = {
                    USER_LOGIN_INFO			:"ILOAN_USER_LOGIN_INFO",
                    PRODUCT_LIST_RES		:"ILOAN_PRODUCT_LIST_RES",
                    PRODUCT_LIST_RES_BANK   :"ILOAN_PRODUCT_LIST_RES_BANK",
                    SELECT_PRO_ITEM			:"ILOAN_SELECT_PRO_ITEM",
                    INFORMATION_TRIAL_RES	:"ILOAN_INFORMATION_TRIAL_RES",
                    BIND_ACCOUNT_LIST   	:"ILOAN_BIND_ACCOUNT_LIST",
                    LOAN_RESULT				:"ILOAN_RESULT",
                    INTO_SHAW_REPAY_PARAM   :"ILOAN_INTO_SHAW_REPAY_PARAM",
                    SHAWREPAYSCHEDULE		:"ILOAN_SHAWREPAYSCHEDULE",
                    INTOSHAWREPAYSCHEDULE	:"ILOAN_INTOSHAWREPAYSCHEDULE",
                    ILOANAPPLYNO			:"ILOAN_APPLYNO",
                    ILOAN_CUSTNO			:"ILOAN_CUSTNO",
                    ILOAN_BILLDAY			:"ILOAN_BILLDAY",
                    PRODUCT_TYPE			:"ILOAN_PRODUCT_TYPE",
                    CARD_DATA				:"ILOAN_CARD_DATA",
                    BEFORE_SOCIAL_OUTHER_HREF	:"ILOAN_BEFORE_SOCIAL_OUTHER_HREF",
                    NEED_CONTACT			:"ILOAN_NEED_CONTACT",
                    FACE_PARAM				:"ILOAN_FACE_PARAM",
                    FACE_STARTTIME			:"ILOAN_FACE_STARTTIME",
                    PHONE_AUTH_FLAG			:"ILOAN_PHONE_AUTH_FLAG",
                    LOANFAIL_CHANGE_TIME	:"ILOAN_FAIL_CHANGE_TIME",
                    CHOOSE_CARD_FROM		:"ILOAN_CHOOSE_CARD_FROM",
                    HASBINDED_CARD_INFO		:"ILOAN_HASBINDED_CARD_INFO",
                    BINDCARD_FROM_SELECT	:"ILOAN_BINDCARD_FROM_SELECT",
                    ACCOUNT_RESULT			:"ILOAN_ACCOUNT_RESULT",
                    REPAYMENT_RESULT		:"ILOAN_REPAYMENT_RESULT",
                    BIND_CARDS_LIST			:"ILOAN_BIND_CARDS_LIST",
                    SELECTCARD_FROM_LIST	:"ILOAN_SELECTCARD_FROM_LIST",
                    SHEBAO_CITY_LIST		:"ILOAN_SHEBAO_CITY_LIST",
                    BINDED_BINDNO			:"ILOAN_BINDED_BINDNO",
                    LOAN_FAIL_FROM_ACCOUNT	:"LOAN_FAIL_FROM_ACCOUNT",
                    LOAN_IS_OD				:"LOAN_IS_OD",
                    FAIL_RETRY_JSON			:"FAIL_RETRY_JSON",
                    FAIL_RETRY_BANKINFO		:"FAIL_RETRY_BANKINFO",
                    ILOAN_LOANSEQ			:"ILOAN_LOANSEQ",
                    ILOAN_EDIT_CONTACT		:"ILOAN_EDIT_CONTACT",
                    ILOAN_INDEX_TYPE		:"ILOAN_INDEX_TYPE",
                    ILOAN_INDEX_TIPMSG		:"ILOAN_INDEX_TIPMSG",
                    UPLOAD_CONTACT_NUM		:'ILOAN_UPLOAD_CONTACT_NUM'
        	};
			$.each(keyjson, function(key, value) {
				C.Utils.data(keyjson[key], null);
			})
        },

        goIloan: function() {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0750,
                eventLable: C.TD.Label.MY_ACCOUNT_0501,
            });
            C.Native.TDOnEvent({
                eventId: C.TD.Event.MY_ACCOUNT_0750,
                eventLable: C.TD.Label.MY_ACCOUNT_0502
            });
            L.goIloan();
        },

        goXindai: function() {
            L.goXindai();
        },
        goCarLife: function (e) {
            var self = this;
            var $target = $(e.currentTarget);
            //埋点
            if ($target.hasClass('sxd')) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.MY_ACCOUNT_0712,
                    eventLable: C.TD.Event.MY_ACCOUNT_0712
                });
            } else {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.MY_ACCOUNT_0713,
                    eventLable: C.TD.Event.MY_ACCOUNT_0713
                });
            }
            if (self.refuseDoubleClick) {
                return false;
            }
            else {
                self.refuseDoubleClick = true;
                
                if (self.isToBrowse == '1'){
                    //跳到外部浏览器
                    C.Native.forwardByBrowse({
                        url: 'http://pingan.com/tppsrc159'
                    });
                } else if (self.isToBrowse == '0') {
                    C.Native.forwardModule({
                        module: 'carlife',
                        url: 'index.html'
                    });
                }
                self.refuseDoubleClick = false;
            }
        }
    }));

    $(function () {
        //标志从i贷,宅e贷返回后需要刷新
        window.needRefresh = false;
        var page = new Page();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function (data) {
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                page.initialize();
            });
        };
        $$.EventListener.pageDidAppear = function () {
            if (!!window.needRefresh) {
                C.Native.getUserInfo(function (data) {
                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                    page.initialize();
                });
                window.needRefresh = false;
            }
        };
        $$.EventListener.onBack = function (url, data) {
            data = (typeof data === 'string') ? JSON.parse(data) : data;
            if (data && data.flag && data.flag == '1') {
                C.Native.getUserInfo(function (data) {
                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                    page.initialize();
                });
            }
        };
    });
});