define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';
    
    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .xbyd,.fdyd,.idai': 'goILoan',
            'tap .zed-more':'goZedApplyRecord'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //当前页面需4个请求
            self.steps = 4;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.APPLY_RATE
            });
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            // 获取城市信息
            self.cityName = C.Utils.data(C.Constant.DataKey.CITY_NAME);
            self.getData();
        },
        // 渲染整个view
        renderiLoan: function (data) {
            var html = _.template($("#iloan-content-tpl").html())({data : data});
            $('.question').html(html);
        },
        renderXB: function (data) {
            var html = _.template($("#xb-content-tpl").html())({data : data});
            $('.question').html(html);
        },
        stopLoading: function () {
            this.steps--;
            if (this.steps <= 0) {
                C.UI.stopLoading();
            }
        },
        getData: function () {
            var self = this;

            //读取网销产品数据，iloan
            var WXBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_WX_BORROW_MONEY);

            if(!!WXBorrowMoney) {
                self.getWXBorrowData(borrowMoney);
            } else {
                $.ajax({
                    type: "get",
                    url: C.Api.QUERY_USERAPPLY_STATE,
                    data: {
                        cityName: self.cityName
                    },
                    success: function (res) {
                        res = (typeof res == 'string') ? JSON.parse(res) : res;
                        if (C.Flag.SUCCESS == res.flag) {
                            self.getWXBorrowData(res.data);
                        } else {
                            self.stopLoading();
                        }
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }

            //读取信保产品数据
            var XBBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_XB_BORROW_MONEY);

            if (!!XBBorrowMoney) {
                self.getXBBorrowData(res.data);
            } else {
                $.ajax({
                    type: "get",
                    url: C.Api.QUERY_XBLOAN_INFO,
                    success: function (res) {
                        if (C.Flag.SUCCESS == res.flag) {
                            self.getXBBorrowData(res.data);
                        } else {
                            self.stopLoading();
                        }
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }
            
            //获取宅e贷借款数据
            var zedBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_ZED_BORROW_MONEY);
            if (!!zedBorrowMoney) {
                self.getZedData(zedBorrowMoney);
                self.stopLoading();
            } else {
                var identifyId = self.userInfo.Id || self.userInfo.id,
                    endDecVer = '1.0.0';
                identifyId = C.rsaEncrypt(identifyId);
                $.ajax({
                    type:"get",
                    url:C.Api.QUERY_ZED_APPLY_RECORD,
                    data:{
                        certId : identifyId || "",
                        clientNo : self.userInfo.accountId,
                        clientModel : "YD",
                        endDecVer : endDecVer
                    },
                    success:function(res){
                        if (res && res.flag==C.Flag.SUCCESS) {
                            if (res.data && res.data.applyMap) {
                                self.getZedData(res.data.applyMap);
                            }
                        } else {
                            self.stopLoading();
                        }
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }
        },
        /*getBorrowData: function (data) {
            var self = this;
            var obj = C.operBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'AP') {
                    return true;
                } else {
                    return false;
                }
            });

            if (obj.borrowList.length > 0) {
                var wxapIndex = -1;
                for (var i=0;i<obj.borrowList.length;i++) {
                    if (obj.borrowList[i].productId == 'idai' && obj.borrowList[i].status == 'AP') {
                        //标记i贷的申请状态，用于重新请求获取状态值
                        wxapIndex = i;
                    }
                }

                //对于网销申请状态,请求searchAppInfo接口确定更详细状态
                if (wxapIndex > -1) {
                    var userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
                    var deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO);
                    var merReserved = C.Utils.data(C.Constant.DataKey.DEVICE_MER_RESERVED);
                    var cityName = C.Utils.data(C.Constant.DataKey.CITY_NAME);
                    $.ajax({
                        type:"get",
                        url:C.Api.SEARCH_APPL_INFO,
                        data:{
                            accountId : userInfo.accountId || '',
                            longitude : deviceInfo.longitude || '',
                            latitude : deviceInfo.latitude || '',
                            merReserved : JSON.stringify(merReserved) || '',
                            cityName : cityName || ''
                        },
                        success:function(res){
                            if (res && res.flag==C.Flag.SUCCESS && res.data) {
                                if (res.data.mark == 'BE') {
                                    obj.borrowList[wxapIndex].moneyStatus = '申请中';
                                } else  if (res.data.mark == 'BN') {
                                    obj.borrowList[wxapIndex].moneyStatus = '已申请';
                                }
                            }
                            self.render(obj.borrowList);
                            self.stopLoading();
                        },
                        error: function (res) {
                            self.render(obj.borrowList);
                            self.stopLoading();
                        }
                    });
                } else {
                    self.render(obj.borrowList);
                    self.stopLoading();
                }
            } else {
                self.stopLoading();
            }
        },*/

        getXBBorrowData: function (data) {
            var self = this;
            var obj = C.operXBFDBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'AP') {
                    return true;
                } else {
                    return false;
                }
            });
            self.renderXB(obj.borrowList);
        },

        getWXBorrowData: function (data) {
            var self = this;
            var obj = C.operWXBorrowData(data);

            self.renderiLoan(obj.borrowList);
            self.stopLoading();
        },

        getZedData: function (applyMap) {
            var self = this;
            
            var applyList = C.operZedData(applyMap);
            //只选取申请状态的
            applyList = applyList.filter(function (item) {
                if ($.inArray(item.statusCode,[1,2,3,4,6,7]) > -1) {
                    return true;
                } else {
                    return false;
                }
            });

            if (applyList.length >= 1) {
                self.showZedData();
            }
        },
        showZedData: function () {
            var html = _.template($("#zed-content-tpl").html())();
            $('.repayment-list').append(html);
        },
        goILoan: function () {
            C.Native.gotoNative('iLoan');
        },
        goZedApplyRecord: function () {
            C.Native.forwardModule({
                module: 'zed',
                url: 'apply_record.html'
            });
        }
    }));

    $(function() {
        new Page();
    });
});