define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .add-bank': 'addBankCard'
        },
        bankListEl:$('#bankList'),
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
            var self = this;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.MY_BANK_CARD,
                //此处是ios处理逻辑
                leftCallback:function () {
                    C.Native.back({
                        url:'',
                        data:{
                            flag:'1'
                        }
                    });
                }
            });
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            C.UI.loading();
            C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    $.ajax({
                        type:"get",
                        url:C.Api.BANK_CARD,
                        success:function(res){
                            res = (typeof res == 'string')?JSON.parse(res):res;
                            if (C.Flag.SUCCESS == res.flag) {
                                var bindCardList = res.data.bindCardList || [];
                                self.render(bindCardList);
                            }
                            C.UI.stopLoading();
                        },
                        error:function (res) {
                            C.UI.stopLoading();
                        }
                    });
                } else {
                    C.Native.tip('尚未登录');
                }
            });
        },
        // 渲染整个view
        render: function (bindCardList) {
            var html = _.template($('#content-tpl').html())({data:bindCardList});
            $('.bank-card').html(html);
        },
        addBankCard: function () {
            var self = this;
            if (!!self.userInfo.paPayToken) {
                C.Native.forward({
                    url: 'bind-card.html'
                });
            } else {
                 C.Native.loginOrRegistPaOne(function () {
                     $$.EventListener.onRefresh();
                });
            }
        }
    }));
    $(function() {
        var bankPage = new Page();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function(data){
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                bankPage.initialize();
            });
        }
        $$.EventListener.onBack = function (url,data) {
            data = (typeof data === 'string') ? JSON.parse(data) : data;
            if (data && data.flag && data.flag == '1') {
                bankPage.initialize();
                C.Native.setHeader({
                    title:C.Constant.TITLE.MY_BANK_CARD,
                    //此处是android处理逻辑
                    leftCallback:function () {
                        C.Native.back({
                            url:'',
                            data:{
                                flag:'1'
                            }
                        });
                    }
                });
            }
        }
    });
});
