define(['zepto', 'C', 'view', 'js/component/identity','js/iloan','js/ipos'], function ($, C, View, Identity, L, iPOS) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .my-history': 'goToMyHistory',
            'tap .watch-myborrow': 'goToLogin', 
            'tap .repay-rightnow': 'goToRepay',
            'tap .idai-product': 'goToiLoanProduct',
            // 'tap .xb-product': 'goToXBProduct',
            'tap .ipos': 'goiPos',
            'tap .zhaiedai': 'goZhai',
            'tap .need-identity': 'needIdentity',
            'tap .zed-more': 'goZedApplyRecord',
            'tap .add-loan-go': 'goAddLoan',
            'tap .add-loan-know': 'knowAddLoan',
            'tap .idai': 'goToiLoanProduct',
            'tap .fdyd': 'goFDXindai',
            'tap .xbyd': 'goXBXindai',
            'tap .czd,.sxd': 'goCarLife'
        },
        leayerEl: $('.leayerApply'),
        myTimeEl: $('.my-time'),
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading(); 
            var self = this;
            //初始化共有5个请求
            self.steps = 5;
            //历史借款数量
            self.fpCount = 0;
            //i贷借款数量
            self.idaiCount = 0;
            /*
             *防重复点击变量
             */
            self.refuseDoubleClick = false;
            //信保借款数量
            self.xbCount = 0;
            //立即还款跳转标示
            self.repayType = '';
            //设置标题
            C.Native.setHeader({
                title: C.Constant.TITLE.MONEY_BORROW
            });
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            self.deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO);
            // 获取城市信息
            self.cityName = C.Utils.data(C.Constant.DataKey.CITY_NAME);
            C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    self.logined = true;
                    if (!!self.userInfo.custId) {
                        $('.need-identity-div,.watch-myborrow-div').hide();
                        $('.borrow-total,.my-borrow-div').show();
                        self.getData();
                    } else {
                        self.steps = self.steps - 5;
                        self.stopLoading();
                        $('.borrow-total,.watch-myborrow-div,.my-borrow-div').hide();
                        $('.need-identity-div').show();
                    }
                } else {
                    self.steps = self.steps - 5;
                    self.stopLoading();
                    $('.borrow-total,.need-identity-div,.my-borrow-div').hide();
                    $('.watch-myborrow-div').show();
                }
            });
        },
        // 渲染整个view
        renderiLoan: function (data) {
            var self = this;

            data.borrowList = data.borrowList || [];
            if (data.lastMoney) {
                var dateLabel = $('#lastMoney-tpl .date').text();
                if(dateLabel && dateLabel != '') {
                    var currentlastDate = C.Utils.parseDateFormat($('#lastMoney-tpl .date').text());

                    if (data.lastDate > dateLabel) {
                        self.repayType = 'idai';
                        var html = _.template($('#lastMoney-tpl').html())({data: data});
                        $('.lastmoney-div').html(html);
                    }
                }
                else {
                    self.repayType = 'idai';
                    var html = _.template($('#lastMoney-tpl').html())({data: data});
                    $('.lastmoney-div').html(html);
                }
            }

            if (data.totalMoney) {
                var currentMoney = parseFloat($('.my-total-borrow .money').text().replace(/,/g, '')) || 0;            
                $('.my-total-borrow .money').html(C.Utils.formatMoney(currentMoney + data.totalMoney, 2));
                $('.my-total-borrow .count').html('共' + data.counts + '笔');
            }
            if (data.borrowList.length > 0) {
                var html = _.template($("#iloan-content-tpl").html())({list: data.borrowList});
                $('.my-borrow-list-empty').hide();
                $('.my-borrow-list').prepend(html).show();
            }
        },

        renderXB: function (data) {
            var self = this;
            data.borrowList = data.borrowList || [];

            if (data.lastMoney) {
                var dateLabel = $('#lastMoney-tpl .date').text();

                if(dateLabel && dateLabel != '') {
                    var currentlastDate = C.Utils.parseDateFormat($('#lastMoney-tpl .date').text());

                    if (data.lastDate > dateLabel) {
                        self.repayType = 'xbfd';
                        var html = _.template($('#lastMoney-tpl').html())({data: data});
                        $('.lastmoney-div').html(html);
                    }
                }
                else {
                    self.repayType = 'xbfd';
                    var html = _.template($('#lastMoney-tpl').html())({data: data});
                    $('.lastmoney-div').html(html);
                }
            }
            
            if (data.totalMoney) {
                var currentMoney = parseFloat($('.my-total-borrow .money').text().replace(/,/g, '')) || 0;            
                $('.my-total-borrow .money').html(C.Utils.formatMoney(currentMoney + data.totalMoney, 2));
                $('.my-total-borrow .count').html('共' + data.counts + '笔');
            }

            if (data.borrowList.length > 0) {
                var html = _.template($("#xb-content-tpl").html())({list: data.borrowList});
                $('.my-borrow-list-empty').hide();
                $('.my-borrow-list').prepend(html).show();
            }
        },
        //渲染车寿数据信息
        showCarLifeData: function (obj) {
            //我的借款金额加入到我的借款总额中
            /*if(obj.totalMoney) {
                var currentMoney = parseFloat($('.my-total-borrow .money').text().replace(/,/g, '')) || 0;
                $('.my-total-borrow .money').html(C.Utils.formatMoney(currentMoney + obj.totalMoney, 2));

                var currentCounts = $('.my-total-borrow .count').text() ? parseInt($('.my-total-borrow .count').text().match(/\d+/).toString()) : 0;
                var counts = currentCounts + obj.counts;
                $('.my-total-borrow .count').html('已放款' + counts + '笔');
            }*/
            if(obj.carlifeList.length > 0) {
                var html = _.template($("#my-carlife-tpl").html())({list: obj.carlifeList});
                $('.my-borrow-list-empty').hide();
                $('.my-borrow-list').append(html).show();
            }
            /*$('.list-account').show();
            if(this.odCount > 0){
                $('.icon-mast').html('<span class="red-dot"></span>');
            }*/
        },

        stopLoading: function () {
            this.steps--;
            if (this.steps <= 0) {
                C.UI.stopLoading();
            }
        },
        getData: function () {
            var self = this;
            $('.my-borrow-list-empty').show();
            $('.my-borrow-list').html('').hide();
            $('.my-total-borrow .money').html('-');
            $('.my-total-borrow .count').html('');

            // 获取信保数据
            $.ajax({
                type: "get",
                url: C.Api.QUERY_XBLOAN_INFO,
                success: function (res) {
                    self.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        self.getXBBorrowData(res.data);
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //获iLoan数据
            $.ajax({
                type: "get",
                url: C.Api.QUERY_USERAPPLY_STATE,
                data: {
                    cityName: self.cityName
                },
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    if (C.Flag.SUCCESS == res.flag) {
                        self.getWXBorrowData(res.data);
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //获取宅e贷申请
            var identifyId = self.userInfo.Id || self.userInfo.id,
                endDecVer = '1.0.0';
            identifyId = C.rsaEncrypt(identifyId);
            $.ajax({
                type: "get",
                url: C.Api.QUERY_ZED_APPLY_RECORD,
                data: {
                    certId: identifyId || "",
                    clientNo: self.userInfo.accountId,
                    clientModel: "YD",
                    endDecVer: endDecVer
                },
                success: function (res) {
                    self.stopLoading();
                    if (res && res.flag == C.Flag.SUCCESS) {
                        if (res.data && res.data.applyMap) {
                            var obj = {
                                length: 1,
                                productId: 'zed-more',
                                iconClass: C.Constant.ICON.zhaiedai,
                                productName: '宅e贷',
                                productStatus : '有抵押',
                                totalBalanceMoney: 0,
                                counts: 0
                            };

                            var applyList = C.operZedData(res.data.applyMap);
                            for (var i = 0; i < applyList.length; i++) {
                                //总借款
                                if(!!applyList[i].balanceMoney) {
                                    obj.counts += 1;
                                    obj.totalBalanceMoney += applyList[i].balanceMoney;
                                }                                
                            }
                            if(res.data.applyMap.length >= 1){
                                $('.zed_borrow').hide();
                            }
                            if (res.data.applyMap.length == 1) {                                
                                var data = applyList[0];
                                if (data.statusCode) {
                                    obj.statusName = data.statusName;
                                    obj.money = data.money;
                                    obj.moneyText = data.moneyText;
                                    self.showZedData(obj);
                                }
                            } else if (res.data.applyMap.length > 1) {
                                obj.productId = 'zed-more';
                                obj.length = res.data.applyMap.length;
                                self.showZedData(obj);
                            }
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //获取车寿借款数据
            $.ajax({
                type: "get",
                url: C.Api.HOME_CAR_LIFE,
                data: {machineSN : self.deviceInfo.MachineSN},
                success: function (res) {
                    self.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        //保存供申请进度和立即还款使用
                        C.Utils.data(C.Constant.DataKey.ACCOUNT_CAR_LIFE, res.data);
                        self.getCarLifeData(res.data);
                        if (res.data.isCheShou == '0' && res.data.applStatus == '0'){
                            self.isToBrowse = '1';
                        } else {
                            self.isToBrowse = '0';
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });

            //检测是否有追加贷款资格
            $.ajax({
                type: "get",
                url: C.Api.QUERY_ADD_LOAN_QUAL,
                success: function (res) {
                    self.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        if (res.data && res.data.isTopup == 'Y' && res.data.hasQualification == 'Y') {
                            var data = res.data;
                            if (data.showTip == 'Y' && data.topupProgress == 0) {
                                var obj = {
                                    name: self.userInfo.custName,
                                    money: (data.isCreditCust == 'Y' && data.creditLine > 0) ? data.creditLine : 0
                                };
                                var html = _.template($("#topup-tpl").html())(obj);
                                $('.add-loan-sec').html(html).show();
                            }
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });
        },
        getCarLifeData: function (data) {
            var self = this;
            var obj = C.operCarLifeData(data);

            self.showCarLifeData(obj);
        },
        showZedData: function (obj) {
            //把宅e贷的借款金额加入到我的借款金额中
            if(obj.totalBalanceMoney) {
                var currentMoney = parseFloat($('.my-total-borrow .money').text().replace(/,/g, '')) || 0;
                $('.my-total-borrow .money').html(C.Utils.formatMoney(currentMoney + obj.totalBalanceMoney, 2));

                var currentCounts = $('.my-total-borrow .count').text() ? parseInt($('.my-total-borrow .count').text().match(/\d+/).toString()) : 0;
                var counts = currentCounts + obj.counts;
                $('.my-total-borrow .count').html('共' + counts + '笔');
            }
            //我的借款列表显示宅e贷借款
            var html = _.template($("#zed-content-tpl").html())(obj);
            $('.my-borrow-list-empty').hide();
            $('.my-borrow-list').append(html).show();
        },

        getXBBorrowData: function (data) {
            var self = this;
            var obj = C.operXBFDBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'FP') {
                    self.fpCount++;
                    return false;
                } else {
                    self.xbCount++;
                    return true;
                }
            });

            if(obj.borrowList && obj.borrowList.length > 0) {
                $('.xb_borrow').hide();
            }
            self.renderXB(obj);
        },

        getWXBorrowData: function (data) {
            var self = this;
            var obj = C.operWXBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'FP') {
                    self.fpCount++;
                    return false;
                } else {
                    self.idaiCount++;
                    return true;
                }
            });

            if(obj.borrowList && obj.borrowList.length > 0) {
                $('.idai_borrow').hide();
            }
            self.renderiLoan(obj);
        },

        goToMyHistory: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0503
            });
            if (!this.fpCount) {
                C.Native.tip('您暂无历史借款信息');
                return;
            }
            C.Native.forward({
                url: 'historical-loan.html'
            })
        },
        goToLogin: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0501,
                eventLable: C.TD.Label.BORROW_MONEY_0501_1
            });
            C.Native.gotoNative('login');
        },

        goToRepay: function(e) {
            var self = this;
            var $target = $(e.currentTarget);

            if ($target.hasClass('repay-rightnow')) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.BORROW_MONEY_0502,
                    eventLable: C.TD.Label.BORROW_MONEY_0502_2
                });
            }

            if (self.logined) {
                window.needRefresh = true;
                // C.Native.gotoNative('iLoan');
                if(self.repayType == 'idai') {
                    L.goIloan();
                } else if(self.repayType == 'xbfd') {
                    L.goXindai();
                }
            } else {
                C.Native.gotoNative('login');
            }
        },

        goToiLoan: function (e) {
            var self = this;
            var $target = $(e.currentTarget);

            if ($target.hasClass('repay-rightnow')) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.BORROW_MONEY_0502,
                    eventLable: C.TD.Label.BORROW_MONEY_0502_2
                });
            }

            if (self.logined) {
                window.needRefresh = true;
                C.Native.gotoNative('iLoan');
            } else {
                C.Native.gotoNative('login');
            }
        },
        goAddLoan: function () {
            $('.add-loan-sec').hide();
            C.Native.getAppVersion(function (res) {
                if (res.version >= 420) {
                    L.goXindai();
                } else {
                    C.Native.gotoNative('iLoan');
                }
            });
        },
        knowAddLoan: function () {
            $('.add-loan-sec').hide();
            $.ajax({
                type: "get",
                url: C.Api.MESSAGE_NOT_TO_REMIND,
                success: function () {
                },
                error: function () {
                }
            });
        },
        goToiLoanProduct: function () {
            var self = this;
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0505
            });
         
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0504,
                eventLable: C.TD.Label.BORROW_MONEY_01,
            });
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0504,
                eventLable: C.TD.Label.BORROW_MONEY_0501,   
            });
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0504,
                eventLable: C.TD.Label.BORROW_MONEY_0502
            });
           
            L.goIloan();
        },
        /*goToXBProduct: function() {
            var self = this;
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0505
            });

            L.goXindai();
        },*/
        goiPos: function () {
            window.needRefresh = true;
            iPOS.initIpos();
        },
        goZhai: function () {
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0507
            });
            window.needRefresh = true;
            C.Native.forwardModule({
                module: 'zed',
                url: 'index_z_apply.html'
            });
        },
        goZedApplyRecord: function () {
            window.needRefresh = true;
            C.Native.forwardModule({
                module: 'zed',
                url: 'apply_record.html'
            });
        },
        goCarLife: function (e) {
            var self = this;
            var $target = $(e.currentTarget);
            //埋点
            if ($target.hasClass('sxd')) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.BORROW_MONEY_0510,
                    eventLable: C.TD.Event.BORROW_MONEY_0510
                });
            } else {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.BORROW_MONEY_0511,
                    eventLable: C.TD.Event.BORROW_MONEY_0511
                });
            }
            if (self.refuseDoubleClick) {
                return false;
            }
            else {
                self.refuseDoubleClick = true;
                
                if (self.isToBrowse == '1'){
                    //跳到外部浏览器
                    C.Native.forwardByBrowse({
                        url: 'http://pingan.com/tppsrc159'
                    });
                } else if (self.isToBrowse == '0') {
                    C.Native.forwardModule({
                        module: 'carlife',
                        url: 'index.html'
                    });
                }
                self.refuseDoubleClick = false;
            }
        },
        needIdentity: function () {
            var identity = new Identity({model: {callback: $$.EventListener.onRefresh}});
            $('body').append(identity.el);
        },
        goFDXindai: function() {
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0506
            });
            L.goXindai();
        },
        goXBXindai: function() {
            C.Native.TDOnEvent({
                eventId: C.TD.Event.BORROW_MONEY_0504
            });
            L.goXindai();
        }
        
    }));

    $(function () {
        window.needRefresh = false;
        var myPage = new Page();

        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function (data) {
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                myPage.initialize();
            });
        };
        $$.EventListener.pageDidAppear = function () {
            if (!!window.needRefresh) {
                C.Native.getUserInfo(function (data) {
                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                    myPage.initialize();
                });
                window.needRefresh = false;
            }
        }
    });
});