define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';
    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        carat:'',
        caratList:'',
        el: 'body',
        speed:'',
        oLength:'',
        userInfoID:'',
        deviceInfo:'',
        token:'',
        longitude:'',
        latitude:'',
        events: {
            "tap .carat-btm":"goCredit",
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.CARAT_CREDIT,
                leftCallback:function(){
                    C.Native.back({
                       //url:"index.html"
                    });
                }
            });
            //获取用户信息
            self.userInfoID = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            C.Native.getUserInfo(function(data){
                self.token=data.token;
            });

            var myDate = new Date(),
            thisTime=myDate.getFullYear()+'-'+(myDate.getMonth()+1)+'-'+myDate.getDate()+' '+myDate.getHours()+':'+myDate.getMinutes()+':'+myDate.getSeconds()
            //console.log(thisTime)
            //C.UI.stopLoading();
            C.UI.loading();
            self.render();
            self.caratInterface();

            setTimeout(function(){
                self.caratInterface();
            },5000);

            //轮询
            setInterval(function(){
                self.caratInterface();
          },60000);
        },

        // 渲染整个carat
        render: function(){
            var self = this;
            $('.carat-btm').animate({
                'transform': 'translateY(-0.2rem)',
                '-webkit-transform': 'translateY(-0.2rem)',
            }, 300,'',function(){
                    $(this).animate({
                        'transform': 'translateY(0rem)',
                        '-webkit-transform': 'translateY(0rem)',
                })
            });

           $('.chart-kl').animate({
                transform: 'scale(1.1) rotate(0deg)',
                '-webkit-transform': 'scale(1.1) rotate(0deg)',
            }, 300,'ease-in-out',function(){
                $(this).animate({
                        transform: 'scale(1) rotate(0deg)',
                        '-webkit-transform': 'scale(1) rotate(0deg)',
                },100,'ease-in-out',function(){
                });
            });

        },
        
        //积分接口调用

        caratInterface:function(){
            var self = this;
            C.Native.getDeviceInfo(function(ress) {
                    $.ajax({
                        url :C.Api.CARAT_INTEGRAL_QUERY ,
                        type:"post",
                        datatype:'json',
                        data:{
                            "accountId":self.userInfoID.accountId,
                            "token":ress.result.token,
                            "gpsCity":ress.result.gpsCity,
                            "longitude":ress.result.longitude,
                            "latitude":ress.result.longitude

                        },
                        success:function(res){
                            //var response=JSON.parse(res);
                            if(res.flag=='1'){
                                C.UI.stopLoading();
                                if(res.data.resultCode=='1'){
                                    self.caratList=res.data.carat;
                                    if(res.data.isAuth){
                                            if(self.caratList&&parseInt(self.caratList)>=0){

                                                    $('.num').html(res.data.carat);
                                                    $('.carat-p').html('评估时间:'+res.data.caratDate).show();
                                                    $('.circle-line ul li').removeClass('focus');
                                                    $('.diamonds-full').css('height','0%');
                                                    $('.diamonds-full .hight').removeClass('shine');
                                                    self.caratGo();
                                                    self.Draw();
                                                    self.diamondsFill();
                                            }else{
                                                    $('.catat-mon .num').html('0');
                                                    $('.icon-dan').css({
                                                        opacity:'1'
                                                    },1000);
                                                    $('.catat-mon .part').css({
                                                        opacity:'1'
                                                    },1000);
                                                    $('.carat-p').css({
                                                        opacity:'1'
                                                    },1000);
                                                    $('.carat-p').html('评估时间:'+res.data.caratDate).hide();
                                                    C.Native.tip(res.data.resultMsg);
                                            }
                                    }else{
                                        C.UI.stopLoading();
                                        }
                                    //C.Native.tip(res.data.resultMsg);
                                }else{  
                                        C.UI.stopLoading();
                                        //C.Native.tip(res.data.resultMsg);
                                     }
                                //C.Native.tip(res.msg);
                            }else{
                                C.UI.stopLoading();
                               //C.Native.tip(res.msg);
                            }
                           C.UI.stopLoading();
                       },

                    });
                });
        },
        //克拉分走字效果
        caratGo: function(){
            var self = this;
            var duu=self.caratList,
                length=duu.length,
                HTML='',
                HTML2='';
                //self.caratList=duu;
                for(var i = 0; i < length; i++){
                    HTML+='<span class="num_one p_relative digit'+i+' ">'
                    +'<span>0</span>'
                    +'<span>1</span>'
                    +'<span>2</span>'
                    +'<span>3</span>'
                    +'<span>4</span>'
                    +'<span>5</span>'
                    +'<span>6</span>'
                    +'<span>7</span>'
                    +'<span>8</span>'
                    +'<span>9</span>'
                +'</span>'    

                    HTML2+='<span class="fraction fraction'+i+'">0</span>'
                };
                    $('.catat-mon .num').html(HTML);
                    $('.catat-mon .num').append(HTML2);
            var     aHeight=$('.p_relative span').height(),
                    j=aHeight*Number(duu.substr(0,1)),
                    k=aHeight*Number(duu.substr(1,1)),
                    l=aHeight*Number(duu.substr(2,1)),
                    m=aHeight*Number(duu.substr(3,1)),
                    n=aHeight*Number(duu.substr(4,1)),
                    o=aHeight*Number(duu.substr(5,1)),
                    p=aHeight*Number(duu.substr(6,1)),
                    q=aHeight*Number(duu.substr(7,1));
                    $('.p_relative').height(aHeight*10);
                    for(var a=0;a<$('.fraction').length;a++){
                        $('.fraction').eq(a).html(duu.substr(a,1))
                    }
            //最大位
           $('.digit0').animate({
                translateY:'-'+j+'px',
                opacity:'1'
            },1000,'ease-in-out',function(){
                $('.icon-dan').css({
                    opacity:'1'
                },1000);
                $('.catat-mon .part').css({
                    opacity:'1'
                },1000);
                $('.carat-p').css({
                    opacity:'1'
                },1000);
                $('.digit0').hide();
                $('.fraction').eq(0).show();
            });

             //右边第二位
           setTimeout(function(){
                $('.digit1').animate({
                    translateY:'-'+k+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit1').hide();
                    $('.fraction').eq(1).show();
                });
            },300);
            //右边第三位
            setTimeout(function(){
                $('.digit2').animate({
                    translateY:'-'+l+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit2').hide();
                    $('.fraction').eq(2).show();
                });
            },500);
           
            //右边第四位
            setTimeout(function(){
                $('.digit3').animate({
                    translateY:'-'+m+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit3').hide();
                    $('.fraction').eq(3).show();
                });
            },700);
            

            
            //右边第五位
            setTimeout(function(){
                $('.digit4').animate({
                    translateY:'-'+n+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit4').hide();
                    $('.fraction').eq(4).show();
                });
            },900);

           
            //右边第六位
            setTimeout(function(){
                $('.digit5').animate({
                    translateY:'-'+o+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit5').hide();
                    $('.fraction').eq(5).show();
                });
            },1100);


            //右边第七位
            setTimeout(function(){
                $('.digit6').animate({
                    translateY:'-'+p+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit6').hide();
                    $('.fraction').eq(6).show();
                });
            },1300);
           

            //右边第八位
            setTimeout(function(){
                $('.digit7').animate({
                    translateY:'-'+q+'px',
                    opacity:'1'
                },1000,'ease-in-out',function(){
                    $('.digit7').hide();
                    $('.fraction').eq(7).show();
                });
            },1500);

           

        },
        //判断是否补录身份信息
        goCredit: function () {
            var self = this;
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            C.Native.login({}, function () {
                //判断是否已补录身份信息
                if (!!self.userInfo.custId) {
                    //埋点
                    C.Native.TDOnEvent({
                    eventId: C.TD.Event.CARAT_CREDIT_0902,
                    eventLable: C.TD.Label.CARAT_CREDIT_090201,
                });
                    self.goGasStation();
                } else {
                    C.Native.addUserInfo(function(res){
                        if(res.code=="1"&&res.msg=='补充身份信息成功'){
                            //埋点
                            C.Native.TDOnEvent({
                            eventId: C.TD.Event.CARAT_CREDIT_0902,
                            eventLable: C.TD.Label.CARAT_CREDIT_090202,
                        });   
                            C.Native.getUserInfo(function(data) {
                                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                            });
                            location.reload();
                        }
                    });
                }
            });
        },
        /*黄色马力盘*/
        Draw: function(){
            var self = this,
                ww='',hh='',
                speed=5,
                index=0,
                oLength=parseInt(self.caratList*$('.circle-line ul li').length/850);
                if(oLength>=$('.circle-line ul li').length){
                    oLength=$('.circle-line ul li').length
                }
                if(self.caratList>=850){
                    speed=20;
                }else{
                    speed=30;
                };
            self.speed=speed;
            self.oLength=oLength;
              var timer=setInterval(function(){
                     if(index>=Math.ceil(oLength)){
                        clearInterval(timer);
                     }else{
                        $('.circle-line ul li').eq(index).addClass('focus')
                        index++;
                    }
                },speed);
   
        },
        /*钻石填充*/
        diamondsFill: function(){
            var self = this;
            var zHeight=self.caratList/850*100;
            if(zHeight>=100){
                zHeight=100;
            }

            $('.diamonds-full').animate({
                height:''+zHeight+'%'
            }, self.speed*self.oLength,'ease-in-out',function(){
                    $('.diamonds-full .hight').addClass('shine')
            });

        },
        //去信息加油站列表
        goGasStation:function(){
            C.Native.forward({
                url: 'credit-information.html'
            });
            
        }
        

    }));
    $(function() {
       
        var Page1 = new Page({
            el:$("body")[0]
        });
       
       /* $$.EventListener.onRefresh = function () {
            console.log(1)
            C.Native.getUserInfo(function(data){
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                Page1.initialize();
            });
        }*/

         $$.EventListener.onBack = function () {
                //location.reload();
                $('.num').html('');
                $('.catat-mon .part').css({opacity:'0'},1000);
                $('.circle-line ul li').removeClass('focus');
                $('.diamonds-full').css('height','0%');
                $('.diamonds-full .hight').removeClass('shine');
                Page1.caratInterface();
        }
        
    });


});