/*!
 * 环境变量，是Common模块的一部分
 * @author 徐晓超
 * @require js/common/env 根据环境变量返回API
 * @history 2015-08-24 add
 */
define([
	"js/common/env",
	"js/common/constant"
	],function(EnvJson,Constant){
	var prefix = "",
        wltUrl = "";
    var env = EnvJson.ssEnv;
	// 易贷优化环境地址
	switch(env){
		case "DEVELOPMENT" :
			prefix = "http://test3-cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://lpms-cust-p5.dmzstg.pingan.com.cn";
			break;
		case "TEST" :
			prefix = "http://test1-cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://lpms-cust-p5.dmzstg.pingan.com.cn";
			break;
		case "STG1" :
			prefix = "http://test1-cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://lpms-cust-p5.dmzstg.pingan.com.cn";
			break;
		case "STG2" :
			prefix = "http://test2-cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://lpms-cust-p5.dmzstg.pingan.com.cn";
			break;
		case "STG3" :
			prefix = "http://test3-cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://lpms-cust-p5.dmzstg.pingan.com.cn";
			break;
		case "PRODUCTION" :
			prefix = "https://cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://txt.pingan.com.cn/static/paem/config/paemhome/paehome_notice";
            wltUrl = "http://www.wanlitong.com";
            break;
		default:
			prefix = "https://cfs-phone-web.pingan.com.cn/cfsssfront";
			jsonUrl = "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice";
            wltUrl = "http://www.wanlitong.com";
	}

	var api = (env == 'DEVELOPMENT') ? {
        //申请状态查询接口
        QUERY_USER_APPLY_STATE: prefix + '/regular/queryUserApplyState.do',
        PLUGIN_LOGIN:prefix + '/V2/login/umLogin.do',
		HOME_CAROUSEL : prefix + '/carousel/carouselPicture.do',
		HOME_CAR_LIFE: prefix + '/V2/business/briefProductInfo.do',
		MONEY_TOTAL : 'data/total-money.json',
		MONEY_BORROW : prefix + '/V2/account/searchSummaryInfo.do',
		QUERY_USERAPPLY_STATE: prefix + '/regular/queryUserApplyState.do',
		QUERY_XBLOAN_INFO: prefix + '/regular/queryXBLoanInfo.do',
		HISTORICAL_LOAN : 'data/historical-loan.json',
		MY_SCORE : prefix +'/V3/business/queryPointsFromWlt.do',
        MY_REGISTRATION : prefix +'/V3/business/signGivePointsFromWlt.do',
        QUICK_NAV: prefix + '/carousel/fastNavigate.do',
        BANK_CARD:prefix + '/eloan/getLoanAccount.do',
        GO_WLT_SHOPING: wltUrl + '/wap/login/league/bind.shtml',
        UPDATE_VERSION: prefix + '/common/updateVersion.do',
        ADD_CUSTOMER_INFO: prefix + '/V3/login/addCustomerInfo.do',
        //绑卡相关接口--换取参数
        QUERY_CARD_INFO:prefix + '/V2/business/queryCardInfo.do',
        //绑卡相关接口--解密接口
		DECRYPTION_REQUESTMSG: prefix + '/V2/business/decryptionRequestMsg.do',
		//绑卡相关接口--查询支持银行列表
		QUERY_BANKCARD_LIST: prefix + '/V2/business/queryBankCardList.do',
		//绑卡相关接口--保存绑卡信息
		BIND_BANK_CARD: prefix + '/V3/business/bindCard.do',
		//查询是否是topup用户
		QUERY_ADD_LOAN_QUAL: prefix + '/V2/business/queryAddLoanQual.do',
		//获取宅e贷的申请记录
		QUERY_ZED_APPLY_RECORD: prefix + '/eloan/getApplyRecords.do',
		SEARCH_APPL_INFO: prefix + '/V4/business/searchApplInfo.do',
		MESSAGE_NOT_TO_REMIND: prefix + '/V2/business/messageNotToRemind.do',

        //申请状态查询接口
        QUERY_USER_APPLY_STATE: prefix + '/regular/queryUserApplyState.do',
        GET_SMSOTP: prefix + '/common/getSMSOtp.do',
		CREATE_ACCOUNT: prefix + '/V2/regist/createAccount.do',
		VERTIFY_SMSOTP: prefix + '/common/vertifySMSOtp.do',
		VERTIFY_REGISTMOBILE: prefix + '/V2/login/vertifyRegistMobile.do',

		//克拉分查询接口
		CARAT_INTEGRAL_QUERY: prefix + '/carat/queryCarat.do',
		//信息加油站列表
		GAS_STATION : prefix + '/carat/queryCreditAuthList.do',
		//信用加油站详细信息查询接口
		DETAILED_INFORMATION: prefix + '/carat/queryCreditAuthDetail.do',
		//数据提交接口
		SUBMIT_CREDIT_AUTH: prefix + '/carat/submitCreditAuth.do',
		//图片获取接口
		FILE_GETTER: prefix + '/common/FileGetter.do',

		// JSON_BANNER:"http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/banner-list.json",
		// JSON_ANNOUNCEMENT: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/announcement.json",
		// JSON_SWICTH: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/switch.json"

		JSON_BANNER: jsonUrl + '/banner-list.json',
		JSON_ANNOUNCEMENT: jsonUrl +  '/announcement.json',
		JSON_SWICTH: jsonUrl +  '/switch.json'
	} : {
        PLUGIN_LOGIN:prefix + '/V2/login/umLogin.do',
		HOME_CAROUSEL : prefix + '/carousel/carouselPicture.do',
		HOME_CAR_LIFE: prefix + '/V2/business/briefProductInfo.do',
		MONEY_TOTAL : prefix + '',
		MONEY_BORROW : prefix + '/V2/account/searchSummaryInfo.do',
		QUERY_USERAPPLY_STATE: prefix + '/regular/queryUserApplyState.do', //(网销接口)
		QUERY_XBLOAN_INFO: prefix + '/regular/queryXBLoanInfo.do', // （信保接口）
		HISTORICAL_LOAN : prefix + '',
        MY_SCORE : prefix +'/V3/business/queryPointsFromWlt.do',
        MY_REGISTRATION : prefix +'/V3/business/signGivePointsFromWlt.do',
        QUICK_NAV: prefix + '/carousel/fastNavigate.do',
        BANK_CARD: prefix + '/eloan/getLoanAccount.do',
        GO_WLT_SHOPING: wltUrl + '/wap/login/league/bind.shtml',
        UPDATE_VERSION: prefix + '/common/updateVersion.do',
        ADD_CUSTOMER_INFO: prefix + '/V3/login/addCustomerInfo.do',
        QUERY_CARD_INFO:prefix + '/V2/business/queryCardInfo.do',
        DECRYPTION_REQUESTMSG: prefix + '/V2/business/decryptionRequestMsg.do',
        QUERY_BANKCARD_LIST: prefix + '/V2/business/queryBankCardList.do',
        BIND_BANK_CARD: prefix + '/V3/business/bindCard.do',
        QUERY_ADD_LOAN_QUAL: prefix + '/V2/business/queryAddLoanQual.do',
		QUERY_ZED_APPLY_RECORD: prefix + '/eloan/getApplyRecords.do',
		SEARCH_APPL_INFO: prefix + '/V4/business/searchApplInfo.do',
		MESSAGE_NOT_TO_REMIND: prefix + '/V2/business/messageNotToRemind.do',
		//ipos相关接口
		QUERY_APPLY_FLAG: prefix + '/pos/queryApplyFlag.do',
		QUERY_APPLY_STATE: prefix + '/pos/queryUserApplyState.do',
		//申请状态查询接口
        QUERY_USER_APPLY_STATE      :prefix+ '/regular/queryUserApplyState.do',
        GET_SMSOTP: prefix + '/common/getSMSOtp.do',
		CREATE_ACCOUNT: prefix + '/V2/regist/createAccount.do',
		VERTIFY_SMSOTP: prefix + '/common/vertifySMSOtp.do',
		VERTIFY_REGISTMOBILE: prefix + '/V2/login/vertifyRegistMobile.do',
		//克查询接口
		CARAT_INTEGRAL_QUERY: prefix + '/carat/queryCarat.do',
		//信息加油站列表
		GAS_STATION : prefix + '/carat/queryCreditAuthList.do',
		//信用加油站详细信息查询接口
		DETAILED_INFORMATION: prefix + '/carat/queryCreditAuthDetail.do',
		//数据提交接口
		SUBMIT_CREDIT_AUTH: prefix + '/carat/submitCreditAuth.do',
		//图片获取接口
		FILE_GETTER: prefix + '/common/FileGetter.do',

		// JSON_BANNER:"http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/banner-list.json",
		// JSON_ANNOUNCEMENT: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/announcement.json",
		// JSON_SWICTH: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/switch.json"

		JSON_BANNER: jsonUrl + '/banner-list.json',
		JSON_ANNOUNCEMENT: jsonUrl +  '/announcement.json',
		JSON_SWICTH: jsonUrl +  '/switch.json'
	};
	return api;
});
