/*!
 * constant 模块常量
 * @module constant
 * @author 周一平
 * @history 2015-6-10 add
 */
define([
	"js/common/flag","js/common/env"
	], function(
		Flag,
        EnvJson
	) {

    /* 平安付配置项 */
    var Env = EnvJson.ssEnv, PAPAY_ENV = EnvJson.pafEnv,
        PAPAY_HOST, PAPAY_AUTH, PAPAY_APP_ID, PAPAY_SECRET, PAPAY_BIND_CARD, PAPAY_BIND_YQB, PAPAY_GET_YQB_ACCOUNT,
        DEBUG_MODE = false;
    if (Env == "PRODUCTION") {
        PAPAY_ENV = "PRD";
    }else{
        DEBUG_MODE = false;
    }
    switch (PAPAY_ENV) {
        case "STG1":
            PAPAY_HOST = "https://test-www.stg.1qianbao.com";
            PAPAY_AUTH = "900000001493 33c6e8446a6c43a5adcf224e7e7a8d6f";
            PAPAY_APP_ID = "900000001493";
            PAPAY_SECRET = "33c6e8446a6c43a5adcf224e7e7a8d6f";
            PAPAY_BIND_CARD = "https://test-www.stg.1qianbao.com/common-bindcard/enterview";
            PAPAY_BIND_YQB = "https://test-www.stg.1qianbao.com/auth";
            PAPAY_GET_YQB_ACCOUNT = "https://test-www.stg.1qianbao.com/token/user";
            PAPAY_HQB_PAGE = "https://test-h5.stg.1qianbao.com:1443/xinbao/index-stg1.html#/earnings/info";
            break;
        case "STG2":
            PAPAY_HOST = "https://test2-www.stg.1qianbao.com:7443";
            PAPAY_AUTH = "900000009498 596ff9657dfb419c85e52eac931207b3";
            PAPAY_APP_ID = "900000009498";
            PAPAY_SECRET = "596ff9657dfb419c85e52eac931207b3";
            PAPAY_BIND_CARD = "https://test2-www.stg.1qianbao.com:7443/common-bindcard/enterview";
            PAPAY_BIND_YQB = "https://test2-www.stg.1qianbao.com:7443/auth";
            PAPAY_GET_YQB_ACCOUNT = "https://test2-www.stg.1qianbao.com:7443/token/user";
            PAPAY_HQB_PAGE = "https://test-h5.stg.1qianbao.com:1443/xinbao/index-stg1.html#/earnings/info";
            break;
        case "PRD":
            PAPAY_HOST = "http://www.1qianbao.com";
            PAPAY_AUTH = "900000004158 2c147337721348908d69fbf4145dd50d";
            PAPAY_APP_ID = "900000004158";
            PAPAY_SECRET = "2c147337721348908d69fbf4145dd50d";
            PAPAY_BIND_CARD = "https://1qianbao.com/common-bindcard/enterview";
            PAPAY_BIND_YQB = "https://1qianbao.com/auth";
            PAPAY_GET_YQB_ACCOUNT = "https://1qianbao.com/token/user";
            PAPAY_HQB_PAGE = "https://h5.1qianbao.com/xinbao/index.html#/earnings/info";
            break;
        default:
            PAPAY_HOST = "http://www.1qianbao.com";
            PAPAY_AUTH = "900000004158 2c147337721348908d69fbf4145dd50d";
            PAPAY_APP_ID = "900000004158";
            PAPAY_SECRET = "2c147337721348908d69fbf4145dd50d";
            PAPAY_BIND_CARD = "https://1qianbao.com/common-bindcard/enterview";
            PAPAY_BIND_YQB = "https://1qianbao.com/auth";
            PAPAY_GET_YQB_ACCOUNT = "https://1qianbao.com/token/user";
            PAPAY_HQB_PAGE = "https://test-h5.stg.1qianbao.com:1443/xinbao/index-stg1.html#/earnings/info";
            break;
    }

    var Constant = {
    	Flag:Flag,
        DEBUG_MODE:DEBUG_MODE,
    	DataKey:{
            // 用户登录数据
            USER_LOGIN_INFO:"USER_LOGIN_INFO",
            USER_LOAN_INFO:"HOME_USER_LOAN_INFO",
            // 保存车寿loanType字段
            CARLIFE_LOANTYPE:"CARLIFE_LOANTYPE",
            SS_APPLY_NO:"HOME_SS_APPLY_NO",
            BANNER_IMG:"BANNER_IMG",
            //首页快捷设置
            HOME_QUICK_NAV:"HOME_QUICK_NAV",
            //卡信息
            CARD_DATA:"HOME_CARD_DATA",
            //deviceInfo
            DEVICE_INFO:"HOME_DEVICE_INFO",
            //设备埋点信息
            DEVICE_MER_RESERVED:"HOME_DEVICE_MER_RESERVED",
            //城市名
            CITY_NAME:"HOME_CITY_NAME",
            //查看支持银行列表缓存
            ALL_BANK_NAME:"HOME_ALL_BANK_NAME",
            ILOAN_BIND_CARD_CONF:"HOME_ILOAN_BIND_CARD_CONF",
            HOME_BIND_CARD_CONF:"HOME_BIND_CARD_CONF",
            HOME_BORROW_MONEY:"HOME_BORROW_MONEY",
            HOME_ZED_BORROW_MONEY:"HOME_ZED_BORROW_MONEY",

            HOME_WX_BORROW_MONEY:"HOME_WX_BORROW_MONEY",
            HOME_XB_BORROW_MONEY:"HOME_XB_BORROW_MONEY",


            //保单数据
            POLICY_DATA:'POLICY_DATA',

            //贷款公司
            PRODUCT_TYPE            :"HOME_PRODUCT_TYPE",
            //申请号
            ILOANAPPLYNO            :"HOME_APPLYNO",
            //账单日
            ILOAN_BILLDAY           :"HOME_BILLDAY",
            //帐户号
            ILOAN_CUSTNO            :"HOME_CUSTNO",
    	},

        BANNER:{
            "data": {
                "attribute": "Y",
                "imagesNameList": [{
                    "link": "null",
                    "img": "../images/index/banner_iPhone-4s-5s_150922.jpg"
                }]
            },
            "msg": "操作成功",
            "flag": "1"
        },

        // 页面标题设置
        TITLE: {
            PAEHOME:'平安e贷',
            MONEY_MAKE:'赚钱',
            MONEY_BORROW:'借钱',
            SETTING:'设置',
            HISTORICAL_LOAN:'历史借款',
            SPEND_MONEY:'花钱',
            MY_SCORE:'我的积分',
            MY_ACCOUNT:'我的账户',
            FAQ:'常见问题',
            ASSETS:'我的总资产',
            QUICK_NAV:'添加快捷导航',
            REPAYMENT_LIST:'还款列表',
            PRODUCTS:'借款产品',
            MY_BANK_CARD:'我的银行卡',
            BIND_CARD:'绑定银行卡',
            APPLY_RATE:'申请进度',
            ACCOUNT_BALANCE:'我的余额',
            CARAT_CREDIT:'克拉信用',
            INSURANCE_CERTIFICATION:'保险认证',
            SOCIAL_CONTACT:"社交帐号认证",
            ADD_INFO:"补充信用信息",
            POLICY_LIFE:'寿险保单'
        },
        ICON:{
            'idai' : 'icon-speed',
            'zhaiedai' : 'icon-fast',
            'tenyuan' : 'icon-free',
            'ipos' : 'icon-ipos',
            'XB' : 'icon-creb',
            'FD' : 'icon-creb',
            'WX' : 'icon-speed',
            'topup' : 'icon-moreone',
            'credit' : 'icon-credit',
            'score' : 'icon-score',
            'car' : 'icon-car',
            'life' : 'icon-life'
        },
        SELECT:{

        },
        CODE:{
            idNo:'01'
        },
        PRODUCTION:{
            CODE:'4'
        },
        // 万里通积分商城的商户ID
        WLT_KEY:'P88003',
        // 平安付请求头授权码
        PAPAY_AUTH: PAPAY_AUTH,
        // 平安付地址
        PAPAY_HOST: PAPAY_HOST,
        // 平安付APP ID
        PAPAY_APP_ID: PAPAY_APP_ID,
        // 平安付密钥
        PAPAY_SECRET: PAPAY_SECRET,
        //平安付绑卡
        PAPAY_BIND_CARD: PAPAY_BIND_CARD,
        //平安付绑定壹钱包
        PAPAY_BIND_YQB: PAPAY_BIND_YQB,
        //平安付换取壹钱包账号
        PAPAY_GET_YQB_ACCOUNT: PAPAY_GET_YQB_ACCOUNT,
        //活钱包页面
        PAPAY_HQB_PAGE: PAPAY_HQB_PAGE
    };
    return Constant;
});
