/*!
 * ui模块 common子模块
 * @module ui
 * @author 周一平 
 * @history 2015-6-10 add
 */
 define(["zepto","js/common/native"],function($,Native){
 	var ui = {
 		loading:function(){
 			Native.loadingBegin();
 		},
 		stopLoading:function(){
			Native.loadingFinish();
 		}
 	};
    // content 第一行说明
    // content2 第二行说明
    $.extend(ui,{
    	error:function(opt){
            var opt = $.extend(opt,{
                icon:'border_bg_red',
                iconText:'X'
            })
    		ui.dialog(opt);
    	},
    	success:function(opt){
    		ui.dialog(opt);
    	},
        warn:function(opt){
            var opt = $.extend({
                icon:'border_bg_red',
                iconText:'!'
            },opt)
            ui.dialog(opt);
        }
    });

	// 设置金额，做成zepto插件
	$.fn.setAmt = function(val){
		val = ((val || "0")*1).toFixed(2);
		var n1 = val.split(".")[0];
		var n2 = val.split(".")[1];
		$(this).addClass("text-amt").html("￥"+n1+". <span>"+n2+"</span> ");
	}
    $.fn.loadHTML = function(url,callback) {
        var $this = $(this);
        $.ajax({
            url: url,
            type: "get",
            dataType: "html",
            xhr: function() {
                return new window.XMLHttpRequest();
            },
            success: function(res) {
                $this.html(res);
                callback && callback(res);
            },
            complete:function(){}

        })
    }

    // 弹出框
 	ui.dialog = (function() {
        var okBtn, cancelBtn, wrap, active = false;
        return function(opt) {
            if (active) return;
            active = true;
            opt = opt || {};
            // succeed_inco 成功 border_bg_red 失败
            opt.icon = opt.icon || "succeed_inco";
            opt.iconText = opt.iconText || "";
            opt.content = opt.content || "";
            opt.content2 = opt.content2 || "";
            opt.content3 = opt.content3 || "";
            // '' 灰 yellow_btn_half 黄色
            opt.okColor = opt.okColor || (!!opt.cancelText ? "yellow_btn_half" : "");
            opt.okText = opt.okText || "确定";
            opt.ok = opt.ok;
            opt.cancelColor = opt.cancelColor || 'green_btn';
            opt.cancelText = opt.cancelText || "";
            opt.cancel = opt.cancel;
            if (!document.getElementById('_cfb_confirm_box')) {
                wrap = document.createElement("div");
                wrap.id = "_cfb_confirm_box";
                wrap.style.display = "none";
                wrap.style.zIndex = "999";
                wrap.className = 'other_mask';
                wrap.innerHTML = [
                    '<div class="'+opt.icon+'">'+opt.iconText+'</div>'+
			        '<p>'+opt.content+'</p>'+
			        '<p style="display:'+(opt.content2?'block':'none')+'">'+opt.content2+'</p>'+
                    '<p style="display:'+(opt.content3?'block':'none')+'">'+opt.content3+'</p>'+
			        '<a href="javascript:;" class="other_btn '+opt.cancelColor+'" id="_cfb_confirm_box_cancel">'+opt.cancelText+'</a>'+
			        '<a href="javascript:;" class="other_btn '+opt.okColor+'" id="_cfb_confirm_box_ok">'+opt.okText+'</a>'].join("");

                document.body.appendChild(wrap);
                var dialogNo = "dialog_" + ~~(Math.random() * 1000000);
                $(document.body).prepend('<div class="mask" id=' + dialogNo + ' style="display:block;z-index:600"></div>');
                okBtn = document.getElementById('_cfb_confirm_box_ok');
                cancelBtn = document.getElementById('_cfb_confirm_box_cancel');
                okBtn.onclick = function() {
                    $('#' + dialogNo + '.mask').remove();
                    $(wrap).remove();
                    active = false;
                    opt.ok && opt.ok();
                }
                cancelBtn.onclick = function() {
                     $('#' + dialogNo + '.mask').remove();
                    $(wrap).remove();
                    active = false;
                    opt.cancel && opt.cancel();
                }
            }
            cancelBtn.style.display = !!opt.cancelText ? "inlineBlock" : "none";
            wrap.style.display = "block";
        }
    })();
    
 	return ui;
});