define(['zepto', 'C', 'view','js/component/identitycodevalid'], function($, C, View, identitycodevalid) {
    'use strict';

    var mytemplate = function () {
        var html = '<div class="dialog" style="margin-top: -2.05rem;">' +
                 '<div class="forms-wrap">' +
                    '<h2 class="icon-identity">请输入身份信息，方便贷款</h2>' +
                    '<div class="forms">' +
                        '<div class="input-box"><div class="input-flex"><input type="text" maxlength="18" class="input identity-num" placeholder="身份证号"></div><div class="icon-photo idCardScan"></div></div>' +
                        '<div class="input-box"><input type="text" class="input identity-name" placeholder="姓名"></div>' +
                    '</div>' +
                    '<div class="btn-flex">' +
                        '<div class="btnG identity-cancel" style="line-height:0.8rem;height:0.8rem">取消</div>' +
                        '<div class="btn identity-certain">确定</div>' +
                    '</div>' +
                '</div>' +
            '</div>';
        return html;
    };

    var Page = View.extend(_.extend({
        tagName: 'section',
        className: 'leayer',
        events: {
            'tap .identity-certain': 'identityCertain',
            'tap .identity-cancel': 'identityCancel',
            'tap .idCardScan': 'idCardScanning'
        },
        template: mytemplate,
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            self.idcardData = '';

            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            self.render();
            C.Native.getChannelId(function (channelId) {
                self.channelId = channelId;
            })
        },
        // 渲染整个view
        render: function (data) {
            this.$el.html(this.template());
            return this;
            
        },
        identityCancel: function () {
            this.remove();
        },
        idCardScanning: function () {
            var self = this;
            C.Native.idCardScanning(function(idCard) {
                if (idCard && idCard.idCardNuber && idCard.userName) {
                    self.idcardData = idCard;
                    self.$el.find("input.identity-num").val(idCard.idCardNuber);
                    self.$el.find("input.identity-name").val(idCard.userName);
                } else {
                    C.Native.tip("身份证扫描失败，请重新扫描正面");
                }
            });
        },
        identityCertain: function() {
            var self = this,
                cardId = $.trim(self.$el.find("input.identity-num").val()),
                custName = $.trim(self.$el.find("input.identity-name").val()),
                userData = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            var validatorIdNo = identitycodevalid(cardId);
            var nameReg = /^[\u4e00-\u9fa5]{2,}$/;
            if (!validatorIdNo.result) {
                C.Native.tip(validatorIdNo.error);
            } else if (!custName) {
                C.Native.tip("请输入姓名");
            } else if (!nameReg.test(custName)) {
                C.Native.tip("请输入正确的中文姓名");
            } else {
                C.UI.loading();

                var idcardData = self.idcardData;
                var upload = (idcardData.imgBytes && idcardData.headImgBytes) ? '1':'0';
                C.Native.upload(C.Api.ADD_CUSTOMER_INFO, {
                        custName: custName || '',
                        id: C.rsaEncrypt(cardId.toUpperCase()),
                        mobile: C.rsaEncrypt(self.userInfo.mobile),
                        channelId: self.channelId || '',
                        isUpload: upload,
                        cardName: idcardData.userName || '',
                        cardSex: idcardData.sex || '',
                        birthday: cardId.substr(6,8) || '',
                        cardNation: idcardData.nation || '',
                        address: C.rsaEncrypt(idcardData.address) || '',
                        os: (App.IS_IOS)?'ios':'android',
                        accountId: userData.accountId,
                        token: userData.token,
                        _RSAVER: "2.1.0",
                        curVer:"3.6.2"
                    },{
                    imgBytes: idcardData.imgBytes || '',
                    headImgBytes: idcardData.headImgBytes || ''
                }, function(res){
                    C.UI.stopLoading();
                    if (res.flag == C.Flag.SUCCESS) {
                        userData.custId = res.data.custId;
                        userData.custName = res.data.custName;
                        userData.paPayToken = res.data.paPayToken;
                        userData.pointsSwitch = res.data.pointsSwitch;
                        C.Native.setUserInfo({
                            custId: userData.custId,
                            id:cardId,
                            Id:cardId,
                            custName: userData.custName,
                            paPayToken: userData.paPayToken,
                            pointsSwitch:userData.pointsSwitch
                        });
                        C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO,userData);
                        if (self.model && self.model.callback) {
                            self.model.callback();
                        }
                        self.remove();
                    } else {
                        C.Native.tip(res.msg);
                    }
                });
            }
            
        }
    }));

    return Page;
});