define(['zepto', 'C', 'view'], function($, C, View) {
	'use strict';
	/**
	 * view业务例子
	 * @author 丘晓强
	 */
	var Demo = View.extend(_.extend({
		// 标签名，可自定义
        tagName: 'section',
        // 类名， 可不填
        className: 'demo',
        // 模板渲染，可不用
        //template: 'template',
        // 事件代理，'动作 元素':'事件'
        events: {
            'click .ev1': 'doEv1',
            'click .ev2': 'doEv2'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            this.render();
        },
        // 渲染整个view
        render: function () {
        	var json = {
        		data: [{
        			name: '1'
        		},{
        			name: '2'
        		}]
        	}
        	this.$el.append(_.template($("#demo").html())({data : json.data}));
        	$('body').append(this.$el);
            console.log(this.$el);
        },
        doEv1: function () {
        	alert(1);
        },
        doEv2: function () {
        	alert(2);
        }
    }));

	$(function() {
		new Demo({
			model: {
				key: 'value'
			}
		});
	});
});