define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';
    
    var Page = View.extend(_.extend({
        tagName: 'section',
        className: '',
        events: {
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.HISTORICAL_LOAN,
                leftCallback:function(){
                    C.Native.back();
                }
            });
            $.ajax({
                type:"get",
                url:C.Api.MONEY_BORROW,
                data:{"_SEARCHSUMMARYINFOVER":"2.0"},
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    
                    if (C.Flag.SUCCESS == res.flag) {
                        var obj = self.operBorrowData(res.data);
                        if (obj.length > 0) {
                            self.render(obj);
                        }
                    }
                }
            });
            C.UI.stopLoading();
        },
        // 渲染整个view
        render: function (data) {
            var html = _.template($('#content-tpl').html())({data:data});
            this.$el.append(html);
            $('body').html(this.$el);
            
        },
        operBorrowData: function (data) {
            var obj = [],
                dataList = data.lnSumLst || false;

            if (dataList && dataList.length>0) {
                for (var i=0;i<dataList.length;i++) {
                    //信保产品
                    if (dataList[i].applType == 'XB') {
                        //正常还款
                        if (dataList[i].status == 'FP') {
                            var XBRP = {
                                productName : '信保易贷',
                                productStatus : "无抵押",
                                money : dataList[i].amt,
                                moneyStatus : '已还清',
                                month : dataList[i].term
                            }
                            obj.push(XBRP);
                            
                        }
                    } else if (dataList[i].applType == 'FD') {
                        //正常还款
                        if (dataList[i].status == 'FP') {
                            var XBRP = {
                                productName : '富登易贷',
                                productStatus : "无抵押",
                                money : dataList[i].amt,
                                moneyStatus : '已还清',
                                month : dataList[i].term
                            }
                            obj.push(XBRP);
                            
                        }
                    }else if(dataList[i].applType == 'zhaiedai'){
                        if (dataList[i].status == 'FP'){
                            var XBRP ={
                                productName : '宅e贷',
                                productStatus : "无抵押",
                                pompt:'本期历史借款暂不包含宅e，预计xxxx升级版本，敬请期待'
                            }
                            obj.push(XBRP);
                        }

                    }
                }
            }
            return obj;
        }
    }));

    $(function() {
        new Page();
    });
});