/**
 * @author: jinmengjie107@pingan.com.cn
 * @date  : 2015-12-11
 * @time  : 下午14:27
 *
 * @describe: iloan及xindai入口逻辑处理代码
 */
define(["zepto","C"],function($,C){
    'use strict';
    var L = {
        iloanConstant : {
            USER_LOGIN_INFO         :"ILOAN_USER_LOGIN_INFO",
            PRODUCT_LIST_RES        :"ILOAN_PRODUCT_LIST_RES",
            PRODUCT_LIST_RES_BANK   :"ILOAN_PRODUCT_LIST_RES_BANK",
            SELECT_PRO_ITEM         :"ILOAN_SELECT_PRO_ITEM",
            INFORMATION_TRIAL_RES   :"ILOAN_INFORMATION_TRIAL_RES",
            BIND_ACCOUNT_LIST       :"ILOAN_BIND_ACCOUNT_LIST",
            LOAN_RESULT             :"ILOAN_RESULT",
            INTO_SHAW_REPAY_PARAM   :"ILOAN_INTO_SHAW_REPAY_PARAM",
            SHAWREPAYSCHEDULE       :"ILOAN_SHAWREPAYSCHEDULE",
            INTOSHAWREPAYSCHEDULE   :"ILOAN_INTOSHAWREPAYSCHEDULE",
            ILOANAPPLYNO            :"ILOAN_APPLYNO",
            ILOAN_CUSTNO            :"ILOAN_CUSTNO",
            ILOAN_BILLDAY           :"ILOAN_BILLDAY",
            PRODUCT_TYPE            :"ILOAN_PRODUCT_TYPE",
            CARD_DATA               :"ILOAN_CARD_DATA",
            BEFORE_SOCIAL_OUTHER_HREF   :"ILOAN_BEFORE_SOCIAL_OUTHER_HREF",
            NEED_CONTACT            :"ILOAN_NEED_CONTACT",
            FACE_PARAM              :"ILOAN_FACE_PARAM",
            FACE_STARTTIME          :"ILOAN_FACE_STARTTIME",
            PHONE_AUTH_FLAG         :"ILOAN_PHONE_AUTH_FLAG",
            LOANFAIL_CHANGE_TIME    :"ILOAN_FAIL_CHANGE_TIME",
            CHOOSE_CARD_FROM        :"ILOAN_CHOOSE_CARD_FROM",
            HASBINDED_CARD_INFO     :"ILOAN_HASBINDED_CARD_INFO",
            BINDCARD_FROM_SELECT    :"ILOAN_BINDCARD_FROM_SELECT",
            ACCOUNT_RESULT          :"ILOAN_ACCOUNT_RESULT",
            REPAYMENT_RESULT        :"ILOAN_REPAYMENT_RESULT",
            BIND_CARDS_LIST         :"ILOAN_BIND_CARDS_LIST",
            SELECTCARD_FROM_LIST    :"ILOAN_SELECTCARD_FROM_LIST",
            SHEBAO_CITY_LIST        :"ILOAN_SHEBAO_CITY_LIST",
            BINDED_BINDNO           :"ILOAN_BINDED_BINDNO",
            LOAN_FAIL_FROM_ACCOUNT  :"LOAN_FAIL_FROM_ACCOUNT",
            LOAN_IS_OD              :"LOAN_IS_OD",
            FAIL_RETRY_JSON         :"FAIL_RETRY_JSON",
            FAIL_RETRY_BANKINFO     :"FAIL_RETRY_BANKINFO",
            ILOAN_LOANSEQ           :"ILOAN_LOANSEQ",
            ILOAN_EDIT_CONTACT      :"ILOAN_EDIT_CONTACT",
            ILOAN_INDEX_TYPE        :"ILOAN_INDEX_TYPE",
            ILOAN_INDEX_TIPMSG      :"ILOAN_INDEX_TIPMSG",
            UPLOAD_CONTACT_NUM      :'ILOAN_UPLOAD_CONTACT_NUM'
        },

        xindaiConstant : {
             // 我的账号详情页申请号applNo
            ACCOUNT_DETAIL_APPLNO: "XINDAI_ACCOUNT_DETAIL_APPLNO",
            // 我的账户详情页存储信息
            ACCOUNT_DETAIL: "XINDAI_ACCOUNT_DETAIL",
            // 壹钱包信息
            YIQIANBAO: "XINDAI_YIQIANBAO",
            QUERY_TOP_UP_CUSTOMER_INFO:"QUERY_TOP_UP_CUSTOMER_INFO",
            LUFAX_INFO:"LUFAX_INFO",
            // 追加贷款信息
            APP_INFO: "XINDAI_APP_INFO",
            // 富登还款还款金额
            FD_REPAY_AMT: "XINDAI_FD_REPAY_AMT",
            // 富登还款界面信息查询数据
            SEARCH_FD_PAY_BASEINFO: "XINDAI_FD_PAY_BASEINFO",
            // 信保还款界面信息查询数据
            SEARCH_PAY_BASEINFO: "XINDAI_SEARCH_PAY_BASEINFO",
            // 平安付token
            PAF_TOKEN: "XINDAI_PAPAF_TOKEN",
            // 壹钱包账户余额
            YIQIANBAO_BALANCE: "XINDAI_YIQIANBAO_BALANCE",
            // 查询追加贷款信息数据
            SEARCH_APPL_INFO: "XINDAI_SEARCH_APPL_INFO",
            // topup信息录单相关数据
            INFORMATION_RECORD: "XINDAI_INFORMATION_RECORD",
            INFORMATION_RECORD_MORE: "XINDAI_INFORMATION_RECORD_MORE",
            INFORMATION_RECORD_FROM: "XINDAI_INFORMATION_RECORD_FROM"
        },
        /*events:{
            'tap .js_iloan,.idai': 'goIloan',
            'tap .js_xindai,.xbyd,.fdyd': 'goXindai'
        },*/


        /**
         * 清除上次存储数据
         * */
        clearLastData: function(key) {
            var _this = this,keyjson;
            if(key=="iloan"){
                keyjson = _this.iloanConstant;
            }else if(key=="xindai"){
                keyjson = _this.xindaiConstant;
            }
            $.each(keyjson, function(key, value) {
                C.Utils.data(keyjson[key], null);
            })
        },

        /**
         * 信贷入口
         * type: 1.topup 表示跳转topup 0.表示信保和topup都可以跳转
         * */
        goXindai: function() {
            var _this = this,
                type = arguments[0] ? arguments[0] : 0;
            C.Native.login({}, function() {
                _this.xindaiClick(type);
            });
        },

        xindaiClick: function(type) {
            var self = this;
            C.Native.getAppVersion(function (res) {
                if (App.IS_ANDROID && res.version>=430) {
                    C.Native.loadingBeginNew('', false);
                } else {
                    C.UI.loading();
                }
            });
            self.clearLastData('xindai');
            C.Native.getUserInfo(function(res) {
                C.Utils.data('XINDAI_USER_LOGIN_INFO', res);
                // 请求searchApplInfo判断mark是否为空
                C.Native.getDeviceInfo(function(res) {
                    if(res.code=='1') {
                        $.ajax({
                            url: C.Api.SEARCH_APPL_INFO,
                            data: {
                                'longitude': res.result.longitude,      // 经度
                                'latitude': res.result.latitude,        // 纬度
                                'merReserved': {},                      // 埋点信息 TODO 需要确认埋点信息
                                'cityName': res.result.gpsCity          // 城市
                            },
                            success: function(result) {
                                if(result.flag=='1') {
                                    if(result.data.mark!='') {
                                        // 请求判断applType是否为空
                                        $.ajax({
                                            url: C.Api.QUERY_XBLOAN_INFO,
                                            type: 'post',
                                            data: {},
                                            success: function(result) {
                                                C.UI.stopLoading();
                                                var isTopupAppl = false,
                                                    topUpInfor = result.data.topUpInfor;
                                                // 追加贷款为普通追加还是topup追加
                                                if(topUpInfor.isTopup=='Y' && topUpInfor.hasQualification=='Y') {
                                                    // topup追加
                                                    isTopupAppl = true;
                                                } else {
                                                    if(type==1) {
                                                        C.Native.tip('暂时无法申请追加，请按时还款、累计信用，下次再试');
                                                        return;
                                                    }
                                                }
                                                if(result.flag=='1') {
                                                    // 判断applType!=XB，或者lnSumLst==0，没有资格
                                                    var has_xb = false;
                                                    for(var i in result.data.lnSumLst) {
                                                        if(result.data.lnSumLst[i].applType=='XB') {
                                                            has_xb = true;
                                                        }
                                                    }
                                                    if(has_xb) {
                                                        C.Native.forwardModule({
                                                            module: 'xindai',
                                                            url: 'supplementary-loan-fail.html'
                                                        });
                                                    } else {
                                                        C.Native.forwardModule({
                                                            module: 'xindai',
                                                            url: 'account.html'
                                                        });
                                                    }
                                                } else {
                                                    C.Native.tip(result.msg);
                                                }
                                            },
                                            error: function() {
                                                C.UI.stopLoading();
                                                C.Native.tip('网络异常，请稍后再试');
                                            }
                                        });
                                    } else {
                                        C.UI.stopLoading();
                                        C.Native.forwardModule({
                                            module: 'xindai',
                                            url: 'account.html'
                                        });
                                    }
                                } else {
                                    C.UI.stopLoading();
                                    C.Native.tip('网络异常，请稍后再试');
                                }
                            },
                            error: function(result) {
                                C.UI.stopLoading();
                                C.Native.tip('网络异常，请稍后再试');
                            }
                        });
                    } else {
                        C.UI.stopLoading();
                        C.Native.tip('查询设备信息出错');
                    }
                });
            });
        },

        /**
         * iloan入口
         * */
        goIloan: function() {
            var _this = this;
            C.Native.login({}, function(){
                _this.iLoanClick();
            });
        },

        iLoanClick: function() {
            var _this = this;
            C.Native.getAppVersion(function (res) {
                if (App.IS_ANDROID && res.version>=430) {
                    C.Native.loadingBeginNew('', false);
                } else {
                    C.UI.loading();
                }
            });
            _this.clearLastData('iloan');
            C.Native.getUserInfo(function(data) {
                C.Utils.data("ILOAN_USER_LOGIN_INFO", data);
                C.Native.getCityName(function(result) {
                    var cityName = result.cityName;
                    if(!cityName){
                        C.Native.forwardModule({
                            module: 'iloan',
                            url: "try_get_cityname.html"
                        });
                        return false;
                    }else{
                        C.Utils.data("ILOAN_CITYNAME",cityName);
                    }
                    $.ajax({
                        url: C.Api.QUERY_USER_APPLY_STATE,
                        type: "post",
                        data: {
                            cityName: cityName
                        },
                        success: function(res) {
                            if (res.flag == "1" && res.data) {
                                var data = res.data;
                                if(data.resultCode == "1") {
                                    if(data.channelCodeFlag=="0"){
                                        C.Native.addUserInfo(function(res){
                                            if(res.code=="1"){
                                                C.Native.getUserInfo(function(data) {
                                                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                                                    _this.iLoanClick();
                                                });
                                            }
                                        });
                                    }else{

                                        //数据缓存
                                        if(data.productType) {
                                            C.Utils.data("ILOAN_PRODUCT_TYPE", data.productType);
                                        }
                                        if(data.applNo) {
                                            C.Utils.data("ILOAN_APPLYNO", data.applNo);
                                        }
                                        if(data.billDate) {
                                            C.Utils.data("ILOAN_BILLDAY", data.billDate);
                                        }
                                        if(data.custNo) {
                                            C.Utils.data("ILOAN_CUSTNO", data.custNo);
                                        }
                                        switch (data.subProcessCode) {
                                            case "AU":
                                            case "XX":
                                            case "RJ":
                                            case "AM":
                                            case "AF":
                                            case "AC":
                                            case "AY":
                                            case "AP":
                                                //跳转到产品介绍页：1、未鉴权，2、申请开关关闭，3、拒绝
                                                C.Utils.data("ILOAN_INDEX_TYPE", data.subProcessCode);
                                                C.Utils.data("ILOAN_INDEX_TIPMSG", data.resultMsg);
                                                C.Native.forwardModule({
                                                    module: 'iloan',
                                                    url: 'iloan_production_index.html?frompage=home'
                                                });
                                                break;
                                            /*case "AP":
                                                C.Native.forwardModule({
                                                    module: 'iloan',
                                                    url : 'credit_info_list.html'
                                                });
                                                break;*/
                                            default:
                                                //非授信环节申请状态处理
                                                C.Native.forwardModule({
                                                    module: 'iloan',
                                                    url: 'shaw_account.html?frompage=home'
                                                })
                                                break;
                                        }

                                    }
                                } else if(data.resultCode == "000001") {
                                    var tiphtml = ['<section id="first_in_tip" class="iloan-leayer">'+
                                                '<div class="iloan-dialog iloan-reminder-tip">'+
                                                '<div class="iloan-rmd-con">'+
                                                    '<h2>温馨提示</h2>'+
                                                    '<div class="iloan-tal">'+ data.resultMsg +'</div>'+
                                                    '<div class="btn iloan-mt30 close_tip_win">我知道了</div>' +
                                                '</div></div></section>'].join('');
                                    $('body').append(tiphtml);
                                    $('.close_tip_win').on('click',function(){
                                        $('#first_in_tip').remove();
                                    });
                                    C.UI.stopLoading();
                                } else {
                                    C.UI.stopLoading();
                                    C.Native.tip(data.resultMsg);
                                }
                            } else {
                                C.UI.stopLoading();
                            }
                        }
                    });
                });
            });
        },
    };
    return L;
});
