define(['zepto', 'C', 'view','swiper', 'js/ipos'], function($, C, View,Swiper) {
	'use strict';
	
	var Home = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .borrow-money': 'borrowMoney',
            'tap .spend-money': 'spendMoney',
            'tap .make-money': 'makeMoney',
            'tap .quick-nav': 'goQuickNav',
            'tap .icon-speed': 'goIdai',
            'tap .icon-moreone': 'goTopup',
            'tap .icon-fast': 'goZhaiedai',
            // 'tap .icon-ipos': 'goIpos',
            'tap .icon-credit': 'goCredit',
            'tap .icon-score': 'goScore',
            'tap .sale-network': 'goSalesNetwork',
            'tap .withdraw': 'goWithdraw'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //设置定制的子项目
            var quickNav = C.Utils.data(C.Constant.DataKey.HOME_QUICK_NAV) || [];
            
            //信用卡绑卡开关
            self.attributeCredit = 'Y';

            self.logined = false;
            C.Account.isLogin(function (data) {
                self.logined = (C.Flag.SUCCESS == data.flag) ? true : false;
            });

            $.ajax({
                type:"get",
                url:C.Api.HOME_CAROUSEL,
                data: {codeId:'carousel_picture'},
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        self.attributeCredit = res.data.attribute || 'Y';
                        self.render(res.data);
                    }
                }
            });
            
            C.UI.stopLoading();
        },
        // 渲染整个view
        render: function (data) {
            var self = this;
            var html = _.template($("#content-tpl").html())({data:data.imagesNameList});
            
            this.$el.find('.homeimg-banner').html(html);
            
            //设置轮播
            var slide = Swiper('.swiper-container', {
                    pagination: '.swiper-pagination',
                    slidesPerView: 1,
                    paginationClickable: true,
                    loop: true,
                    preloadImages: false,
                    lazyLoading: true
                });
        },
        borrowMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId:C.TD.Event.HOME_PAGE,
                eventLable:C.TD.Label.HOME_PAGE_0204
            });
            C.Native.forward({
                url: 'borrow-money.html'
            });
        },
        spendMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId:C.TD.Event.HOME_PAGE,
                eventLable:C.TD.Label.HOME_PAGE_0205
            });
            C.Native.forward({
                url: 'spend-money.html?attributeCredit=' + this.attributeCredit
            });
        },
        makeMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId:C.TD.Event.HOME_PAGE,
                eventLable:C.TD.Label.HOME_PAGE_0206
            });
            C.Native.forward({
                url: 'make-money.html'
            });
        },
        goIpos: function () {
            C.Native.forwardModule({
                module: 'ipos',
                url: 'ipos_index.html'
            });
        }
    }));

	$(function() {
		var home = new Home();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function(data){
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                home.initialize();
            });
        }
	});
});