define(['zepto', 'C', 'view', 'swiper', 'js/iloan', 'js/ipos'], function ($, C, View, Swiper, L, iPOS) {
    'use strict';
    var Home = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .borrow-money': 'borrowMoney',
            'tap .spend-money': 'spendMoney',
            'tap .make-money': 'makeMoney',
            'tap .quick-nav': 'goQuickNav',
            'tap .icon-speed': 'goIdai',
            'tap .icon-moreone': 'goTopup',
            'tap .icon-fast': 'goZed',
            'tap .icon-ipos': 'goIpos',
            'tap .icon-credit': 'goCredit',
            'tap .icon-score': 'goScore',
            'tap .sale-network': 'goSalesNetwork',
            'tap .withdraw': 'goWithdraw',
            'tap .icon-car,.icon-life': 'goCarLife',
            'click .swiper-img': 'jumpSwiper',
            'tap .transfer_link': 'jumpNotice',            
            'tap .add-loan-go': 'goAddLoan',
            'tap .add-loan-know': 'knowAddLoan',
            'tap .icon-topup': 'goMobilefare',
            'tap .close_zone': 'delNotice'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
            var self = this;
            /*
             *初始化3个异步请求
             */
            self.requestSteps = 3;
            // 判断是否显示ipos入口
            self.isIpos = false;
            //判断当前app版本是否在4.4.0以上
            self.isMobilefare = false;

            self.comBlank = 0;

            self.lockjump = true;
            /*
             *设置定制的子项目
             */
            var quickNav = C.Utils.data(C.Constant.DataKey.HOME_QUICK_NAV) || [];
            self.iconList = quickNav;
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO) || {};
            self.deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO) || {};
            /*
             *信用卡绑卡开关
             */
            self.attributeCredit = 'N';
            /*
             *话费充值开关
             */
            self.attributeMobilefee = 'N';
            
            self.linkbrowser = '';

            /*
             *防重复点击变量
             */
            self.refuseDoubleClick = false;
            /*
             *是否有追加贷款资格;N没有Y有
             */
            self.addLoan = 'N';
            /*
             *是否显示车寿入口图标
             */
            self.showIconCar = true;
            /*
             *区分车主贷与寿险贷图标
             */
            self.diffIconCarLife = '';
            /*
             *判断是否跳转外部浏览器变量
             */
            self.isToBrowse = '';

            //读取Banner缓存
            self.localBannerList=C.Utils.data(C.Constant.DataKey.BANNER_IMG);

            C.Native.getAppVersion(function (res) {
                if (res.version >= 450) {
                    self.isIpos = true;

                } else {
                    self.isIpos = false;
                }
            });            
            //查询开关接口
            self.querySwitch();
            self.setQuickNav(self.iconList);
            self.completeColumns();

            $.ajax({
                type: "get",
                url: C.Api.JSON_ANNOUNCEMENT,
                // url: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/announcement.json",
                contentType:"application/x-www-form-urlencoded:charset=UTF-8",
                //url: "../data/announcement.json",                
                success: function (res) {
                    self.stopLoading();
                    res = (typeof res == 'string') ? JSON.parse(res) : res;

                    if(res.announcement&&res.announcement.length>0){
                        if(res.announcement[0].content && 
                           res.announcement[0].content != '') {
                            self.linkbrowser = res.announcement[0].link;
                            $('.affiche').show();
                        }
                    } 

                    self.showNotice(res.announcement);
                    self.scroll();
                    if(self.scroll()==true){
                        if(navigator.userAgent.indexOf("iPhone")>-1){
                            var p_w=$('.con').width();
                            var txtWidth=$('.txt').width();
                            //console.log(p_w,txtWidth);
                            var count=0;
                            $('.con').css("margin-left","5.2rem");
                            if(count != p_w){
                                setInterval(function() {
                                    if(p_w >= txtWidth){
                                        count=++count;
                                        //console.log(count);
                                        $('.con').animate({'left':-count+"px"},{easing:'linear'});
                                        if(count == p_w) {
                                            clearInterval();
                                            count=0;
                                        }
                                    }
                                },15);
                            }
                        }else if(navigator.userAgent.indexOf("Android")>-1){
                            self.showNotice_more(res.announcement);
                        }
                    }
                },
                error: function () {
                    self.stopLoading();
                }
            });           

            /*
             *获取首页轮播图及信用卡开关
             */
            if(self.localBannerList){
                self.render(self.localBannerList);

                $.ajax({
                    type: "get",
                    url: C.Api.JSON_BANNER,
                    // url: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/banner-list.json",
                    //url: "../data/banner-list.json",
                    // data: {codeId: 'carousel_picture'},
                    success: function (res) {
                        res = (typeof res == 'string') ? JSON.parse(res) : res;
                        if (C.Flag.SUCCESS == res.flag) {
                            C.Utils.data(C.Constant.DataKey.BANNER_IMG,res.data);
                            self.localBannerList=res.data;
                            //self.attributeCredit = res.data.attribute || 'Y';
                            self.render(self.localBannerList);
                        }
                        else{
                            C.Utils.data(C.Constant.DataKey.BANNER_IMG,'');
                        }

                        self.localBannerList=C.Utils.data(C.Constant.DataKey.BANNER_IMG);

                        self.stopLoading();
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }
            else{
                C.Utils.data(C.Constant.DataKey.BANNER_IMG,C.Constant.BANNER.data);
                self.localBannerList=C.Constant.BANNER.data;
                self.render(self.localBannerList);

                $.ajax({
                    type: "get",
                    url: C.Api.JSON_BANNER,
                    // url: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/banner-list.json",
                    //url: "../data/banner-list.json",
                    // data: {codeId: 'carousel_picture'},
                    success: function (res) {
                        res = (typeof res == 'string') ? JSON.parse(res) : res;
                        if (C.Flag.SUCCESS == res.flag) {

                            C.Utils.data(C.Constant.DataKey.BANNER_IMG,res.data);
                            self.localBannerList=res.data;
                            //self.attributeCredit = res.data.attribute || 'Y';
                            self.render(self.localBannerList);
                        }
                        else{
                            C.Utils.data(C.Constant.DataKey.BANNER_IMG,'');
                        }

                        self.localBannerList=C.Utils.data(C.Constant.DataKey.BANNER_IMG);

                        self.stopLoading();
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }
            
            C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    /*
                     *检测是否显示车寿入口图标
                     */
                    $.ajax({
                        type: "get",
                        url: C.Api.HOME_CAR_LIFE,
                        data: {machineSN: self.deviceInfo.MachineSN},
                        success: function (res) {
                            self.stopLoading();
                            if (C.Flag.SUCCESS == res.flag && res.data) {
                                // 0：申请中
                                // 1：待放款
                                // 2：已放款
                                // 3：还款中
                                // 4：取消
                                // 5：拒绝
                                C.Utils.data(C.Constant.DataKey.CARLIFE_LOANTYPE, res.data);
                                if(res.data.applStatus == '0') {
                                    $('.li-car').show();
                                    self.showIconCar = true;

                                    if (res.data.loanType == 14){
                                        self.diffIconCarLife = 'Y0';
                                    } else if (res.data.loanType == 15){
                                        self.diffIconCarLife = 'Y1';
                                    }
                                } else if (res.data.applStatus == '1' || res.data.applStatus == '2'){
                                    $('.li-car').show();
                                    self.showIconCar = true;

                                    if (res.data.loanType == 14){
                                        self.diffIconCarLife = 'YC';
                                    } else if (res.data.loanType == 15){
                                        self.diffIconCarLife = 'YS';
                                    }
                                } else {
                                    $('.li-car').hide();
                                    self.showIconCar = false;
                                    self.diffIconCarLife = 'N';
                                }
                                if (res.data.isCheShou == '0' && res.data.applStatus == '0'){
                                    self.isToBrowse = '1';
                                } else {
                                    self.isToBrowse = '0';
                                }
                                // 重新渲染页面
                                self.setQuickNav(quickNav);
                                //self.querySwitch();
                                self.completeColumns();
                            }                            
                        },
                        error: function () {
                            self.stopLoading();
                        }
                    });

                    /*
                     *检测是否有追加贷款资格
                     */
                    $.ajax({
                        type: "get",
                        url: C.Api.QUERY_ADD_LOAN_QUAL,
                        success: function (res) {
                            self.stopLoading();
                            if (C.Flag.SUCCESS == res.flag) {
                                if (res.data && res.data.isTopup == 'Y' && res.data.hasQualification == 'Y') {
                                    var data = res.data;
                                    //是否有追加贷款资格
                                    self.addLoan = 'Y';
                                    if (data.showTip == 'Y' && data.topupProgress == 0) {
                                        var obj = {
                                            name : self.userInfo.custName,
                                            money : (data.isCreditCust == 'Y' && data.creditLine > 0) ? data.creditLine : 0
                                        };
                                        var html = _.template($("#topup-tpl").html())(obj);
                                        $('.add-loan-sec').html(html).show();
                                    }
                                }
                            }
                        },
                        error: function () {
                            self.stopLoading();
                        }
                    });                   
                } else {
                    self.showIconCar = false;
                    self.setQuickNav(quickNav);
                    self.querySwitch();
                    self.completeColumns();
                    self.requestSteps = self.requestSteps - 3;
                    self.stopLoading();
                }
            });
        },

        completeColumns:function(){
            var self=this;
            //self.len=$('.list li').length;
            self.len=$('.cur_li').find('.oldtag').length;
            //console.log(self.len);
            if(self.len%4==0){
                self.comBlank=0;
                //console.log(1);
                $('.line_gray').remove();
            }else if(self.len%4==1){
                self.comBlank=3;
                //console.log(2);
                $('.cur_li').append('<li class="line_gray"></li>'+
                                     '<li class="line_gray"></li>'+
                                     '<li class="line_gray"></li>');
            }else if(self.len%4==2){
                self.comBlank=2;
                //console.log(3);
                $('.cur_li').append('<li class="line_gray"></li>'+
                                     '<li class="line_gray"></li>');
            }else if(self.len%4==3){
                self.comBlank=1;
                //console.log(4);
                $('.cur_li').append('<li class="line_gray"></li>');
            }
        },

        scroll:function(){
            var div_w = $("#txt").width(),
                p_w = $(".con").width();
                //console.log(div_w,p_w);
            if(div_w<p_w){
                return true;
            }

        },
        querySwitch: function(){
            var self = this;
            C.Native.getAppVersion(function (res) {
                 if (res.version >= 440) {
                     self.isMobilefare = true;
                    
                     //$('.mobilefare').show();

                 } else {
                     self.isMobilefare = false;
                     
                     //$('.mobilefare').hide();
                 }
             });

            //self.scroll();
            // 显示信用卡和话费充值入口
            $.ajax({
                type: "get",
                url: C.Api.JSON_SWICTH,
                // url: "http://nts-tms-dmzstg1.pingan.com.cn:9027/html-dev/paehome_notice/switch.json",
                contentType:"application/x-www-form-urlencoded:charset=UTF-8",
                //url: "../data/switch.json",
                success: function (res) {
                    res = (typeof res == 'string') ? JSON.parse(res) : res;
                    //信用卡绑卡开关
                    self.attributeCredit = res.data.attribute || 'Y';
                    self.attributeMobilefee = res.data.attributefee || 'Y';
                    /*if(self.attributeCredit=='Y'){
                        $('.creditCard').show();
                    }else{
                        $('.creditCard').hide();
                    }
                    if(self.attributeMobilefee=='Y'&&self.isMobilefare == true){
                        $('.mobilefare').show();
                    }else{
                        $('.mobilefare').hide();
                    }*/

                    //self.completeColumns();

                    self.setQuickNav(self.iconList);
                    self.completeColumns();
                    
                    self.stopLoading();
                },
                error: function (e) {
                    console.log(e);
                    self.stopLoading();
                }
            });
        },

        delNotice:function(){
            $(".affiche").hide();
            $(".transfer_link").hide();
        },

        showNotice:function(data){
            var self = this;
            var html=_.template($("#notice-tpl").html())({data:data});
            this.$el.find('.txt').html(html);
        },

        showNotice_more:function(data){
            var self = this;
            var html=_.template($("#noticescroll-tpl").html())({data:data});
            this.$el.find('.txt').html(html);
        },        

        // 渲染整个view
        render: function (data) {
            var self = this;
            var html = _.template($("#content-tpl").html())({data: data.imagesNameList});

            this.$el.find('.homeimg-banner').html(html);

            //设置轮播
            self.slide = Swiper('.swiper-container', {
                pagination: '.swiper-pagination',
                slidesPerView: 1,
                paginationClickable: true,
                loop: true,
                preloadImages: false,
                lazyLoading: true
            });
        },
        stopLoading: function () {
            var self = this;
            self.requestSteps--;
            if (self.requestSteps <= 0) {
                C.UI.stopLoading();
            }
        },
        borrowMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_0204
            });
            C.Native.forward({
                url: 'borrow-money.html'
            });
        },
        spendMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_0205
            });
            C.Native.forward({
                url: 'spend-money.html?attributeCredit=' + this.attributeCredit

            });
        },
        makeMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_0206
            });
            C.Native.forward({
                url: 'make-money.html'
            });
        },
        goQuickNav: function () {
            var self = this;
            C.Native.forward({
                url: 'quick-nav.html',
                data: {attributeCredit: self.attributeCredit}
            });
        },
        setQuickNav: function (data) {
            var self = this;
            for (var i = 0; i < data.length; i++) {
                data[i].icon = C.Constant.ICON[data[i].id];
            }
            var obj = {
                data: data,
                attributeCredit: self.attributeCredit,
                attributeMobilefee: self.attributeMobilefee,
                pointsSwitch: (self.userInfo.pointsSwitch == 'Y') ? 'Y' : 'N',
                showIconCar: self.showIconCar ? 'Y' : 'N',
                diffIconCarLife: self.diffIconCarLife,
                isIpos: self.isIpos ? 'Y' : 'N',
                isMobilefare: self.isMobilefare
                //comBlank:self.comBlank
            };
            //console.log(self.attributeCredit, self.attributeMobilefee);
            var html = _.template($('#features-tpl').html())(obj);
            $('.features').html(html);
        },
        goIdai: function () {
            
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_02012
            });
          
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE_0207,
                eventLable: C.TD.Label.HOME_PAGE_01,
            });
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE_0207,    
                eventLable: C.TD.Label.HOME_PAGE_0501,
            });
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE_0207,
                eventLable: C.TD.Label.HOME_PAGE_0502
            });
            C.Native.getAppVersion(function (res) {
                if (res.version >= 420) {
                    L.goIloan();
                } else {
                    C.Native.gotoNative('iLoan');
                }
            });
        },
        goAddLoan: function () {
            $('.add-loan-sec').hide();
            C.Native.getAppVersion(function (res) {
                if (res.version >= 420) {
                    L.goXindai();
                } else {
                    C.Native.gotoNative('iLoan');
                }
            });
        },
        knowAddLoan: function () {
            $('.add-loan-sec').hide();
            $.ajax({
                type: "get",
                url: C.Api.MESSAGE_NOT_TO_REMIND,
                success: function () {
                },
                error: function () {
                }
            });
        },
        goSalesNetwork: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_02017
            });
            C.Native.gotoNative('salesNetwork');
        },
        goTopup: function () {
            var self = this;
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_02014
            });
           C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
                    if (!!self.userInfo.custId) {
                        if (self.addLoan == 'Y') {
                            L.goXindai(1);
                        } else {
                            C.Native.tip('暂时无法申请追加，请按时还款、累计信用，下次再试');
                        }
                    } else {
                        C.Native.addUserInfo(function(res){
                            if(res.code=="1"){
                                $$.EventListener.onRefresh();
                                /*C.Native.getUserInfo(function(data) {
                                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                                });*/
                            }
                        });
                    }
                } else {
                    C.Native.login({}, function () {
                        C.UI.loading();

                        self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
                        if (!!self.userInfo.custId) {
                            $.ajax({
                                type: "get",
                                url: C.Api.QUERY_ADD_LOAN_QUAL,
                                success: function (res) {
                                    C.UI.stopLoading();
                                    if (C.Flag.SUCCESS == res.flag) {
                                        if (res.data && res.data.isTopup == 'Y' && res.data.hasQualification == 'Y') {
                                            L.goXindai(1);
                                        } else {
                                            C.Native.tip('暂时无法申请追加，请按时还款、累计信用，下次再试');
                                        }
                                    }
                                },
                                error: function () {
                                    C.UI.stopLoading();
                                }
                            });
                        } else {
                            C.Native.addUserInfo(function(res){
                                if(res.code=="1"){
                                    $$.EventListener.onRefresh();
                                    /*C.Native.getUserInfo(function(data) {
                                        C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                                    });*/
                                }
                            });
                        }
                    });
                }
            });
        },
        goZed: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE,
                eventLable: C.TD.Label.HOME_PAGE_02013
            });
            C.Native.forwardModule({
                module: 'zed',
                url: 'index_z_apply.html'
            });
        },
        goIpos: function () {
            // 埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE_0221,
                eventLable: C.TD.Event.HOME_PAGE_0221
            });
            
            var ua = navigator.userAgent.toUpperCase();
            if (ua.indexOf('ANDROID') > -1) {
                C.Native.getAppVersion(function (res) {
                    if (res.version >= 430) {
                        C.Native.loadingBeginNew('','false');
                    }
                });
            }
            iPOS.initIpos();
        },
        goBannerIpos: function () {
            // 埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.HOME_PAGE_0222,
                eventLable: C.TD.Event.HOME_PAGE_0222
            });
            iPOS.initIpos();
        },
        goCarLife: function (e) {
            var self = this;
            var $target = $(e.currentTarget);
            //埋点
            if ($target.hasClass('icon-life')) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.HOME_PAGE_0218,
                    eventLable: C.TD.Event.HOME_PAGE_0218
                });
            } else {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.HOME_PAGE_0219,
                    eventLable: C.TD.Event.HOME_PAGE_0219
                });
            }
            if (self.refuseDoubleClick) {
                return false;
            }
            else {
                self.refuseDoubleClick = true;
                
                if (self.isToBrowse == '1'){
                    //跳到外部浏览器
                    C.Native.forwardByBrowse({
                        url: 'http://pingan.com/tppsrc159'
                    });
                } else if (self.isToBrowse == '0') {
                    C.Native.forwardModule({
                        module: 'carlife',
                        url: 'index.html'
                    });
                }
                self.refuseDoubleClick = false;
            }
        },
        goCredit: function () {
            var self = this;
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            C.Native.login({}, function () {
                //判断是否已补录身份信息
                if (!!self.userInfo.custId) {
                    //判断是否绑定壹钱包
                    if (!!self.userInfo.paPayToken) {
                        C.Native.gotoNative('creditCardRepayment');
                    } else {
                        C.Native.loginOrRegistPaOne(function (json) {
                            if (C.Flag.SUCCESS == json.code) {
                                C.Native.getUserInfo(function(data){
                                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                                    self.userInfo = data;
                                    if (!!self.userInfo.paPayToken) {
                                        C.Native.gotoNative('creditCardRepayment');
                                    }
                                });
                            }
                        });
                    }
                } else {
                    C.Native.addUserInfo(function(res){
                        if(res.code=="1"){
                            //$$.EventListener.onRefresh();
                            C.Native.getUserInfo(function(data) {
                                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                            });
                        }
                    });
                }
            });
        },

        goMobilefare:function(){

            var self = this;
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);

            C.Native.login({}, function () {
               
                if (!!self.userInfo.custId) {
                    
                  if (!!self.userInfo.paPayToken) {
                    C.Native.prepaidRecharge('mobileFareRecharge');
                    } else {
                        C.Native.loginOrRegistPaOne(function (json) {
                            if (C.Flag.SUCCESS == json.code) {
                                C.Native.getUserInfo(function(data){
                                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                                    self.userInfo = data;
                                    if (!!self.userInfo.paPayToken) {
                                        C.Native.prepaidRecharge('mobileFareRecharge');
                                    }
                                });
                            }
                        });
                    }
                }else {
                    
                    C.Native.addUserInfo(function(res){
                        if(res.code=="1"){
                            //$$.EventListener.onRefresh();
                            C.Native.getUserInfo(function(data) {
                                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                            });
                        }
                    });
                }
            });
        },

        goScore: function () {
            C.Native.login({}, function () {
                C.Native.forward({
                    url: 'my-score.html'
                });
            });
        },
        goWithdraw: function (e) {
            var self = this,
            //转入转出埋点
                isInto = $(e.target).hasClass('icon-change-into'),
                eventId = C.TD.Event.HOME_PAGE,
                eventLable = C.TD.Label.HOME_PAGE_02016;
            if (isInto) {
                eventId = C.TD.Event.HOME_PAGE;
                eventLable = C.TD.Label.HOME_PAGE_02015;
            }
            C.Native.TDOnEvent({
                eventId: eventId,
                eventLable: eventLable
            });
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            C.Native.login({}, function () {
                //判断是否绑定平安付
                if (!!self.userInfo.paPayToken) {
                    C.Native.jumpToYiQianBao();
                } else {
                    C.Native.loginOrRegistPaOne(function () {
                        $$.EventListener.onRefresh();
                    });
                }
            });
        },

        //轮播图的点击跳转
        jumpSwiper: function (e) {
            var self = this,
                target = $(e.currentTarget),
                dataLink = target.attr('data-link');

            if(!self.lockjump){
                return false;
            }

            self.lockjump = false;
            // 轮播图只埋前五个图片
            if (self.slide.clickedIndex <= 5) {
                C.Native.TDOnEvent({
                    eventId: C.TD.Event.HOME_PAGE,
                    eventLable: C.TD.Label['HOME_PAGE_020' + (self.slide.clickedIndex + 6)]
                });
            }
            switch (dataLink) {
                case 'spendmoney':
                    self.spendMoney();
                    break;
                case 'borrowmoney':
                    self.borrowMoney();
                    break;
                case 'makemoney':
                    self.makeMoney();
                    break;
                case 'ipos':
                    self.goBannerIpos();
                    break;
                case 'zed':
                    self.goZed();
                    break;
                case 'iloan':
                    self.goIdai();
                    break;
                case 'topup':
                    self.goTopup();
                    break;
                default:
                    if (dataLink.indexOf('http://') == 0) {
                        C.Native.forward({
                            url: dataLink
                        });
                    }
            }

            self.lockjump = true;
        },

        jumpNotice: function (e) {
            var self = this,
                target = $(e.currentTarget),
                //dataLink = target.attr('data-link');
                dataLink = self.linkbrowser;
                if(!self.lockjump){
                    return false;
                }

                self.lockjump = false;

                if (dataLink.indexOf('http://')==0) {
                    //console.log('link');
                    C.Native.forward({
                        url: dataLink
                    });
                }
                else if(dataLink.indexOf('https://') == 0){
                    C.Native.forward({
                        url: dataLink
                    });                    
                }

                self.lockjump = true;
        }        

    }));

    $(function () {
        var home = new Home();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function (data) {
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                home.initialize();
            });
        }
    });
});
