/**
 * @author: jinmengjie107@pingan.com.cn
 * @date  : 2015-11-03
 * @time  : 下午20:27
 * 
 * @describe: ipos入口逻辑处理代码
 */
define(["zepto","C","view"],function($,C,View){
    'use strict';
    var iPOS = {
        Constant : {
            USER_LOGIN_INFO:"POS_USER_LOGIN_INFO",
            USER_LOAN_INFO:"POS_USER_LOAN_INFO",
            SS_APPLY_NO:"POS_SS_APPLY_NO",
            RES_CREDIT_POS:"POS_RES_CREDIT_POS",
            RES_CREDIT_SHOP:"POS_RES_CREDIT_SHOP",
            ESIGN_DATA:"POS_ESIGN_DATA",
            BIND_CARDS_LIST:"POS_BIND_CARDS_LIST",
            CREDIT_BUSINESS_RESULT:"POS_CREDIT_BUSINESS_RESULT",
            ALLBANKNAME:"POS_ALL_BANK_NAME",
            CARD_DATA:"POS_CARD_DATA",
            DEVICE_INFO:"POS_DEVICE_INFO",
            LUFAX_DATA:"POS_LUFAX_DATA",
            LUFAX_MOBILE:"LUFAX_DATA_MOBILE",
            CARD_REPEAT_DATA:"POS_CARD_REPEAT_DATA",
            POS_DRAWNO:"POS_DRAWNO",
            POS_ACCTNO:"POS_ACCTNO",
            POS_CAN_APPLY:"POS_CAN_APPLY",
            POS_CUST_TYPE:"POS_CUST_TYPE",
            POS_FIRSTTIP:"POS_FIRSTTIP",
            POS_FIRSTFZTIP:"POS_FIRSTFZTIP",
            POS_ISRJTIP:"POS_ISRJTIP",
            POS_CREDITLINE:"POS_CREDITLINE",
            POS_LOOPDRAWNO:"POS_LOOPDRAWNO",
            POS_GETSUCCESS:"POS_GETSUCCESS",
            POS_BRCODE:"POS_BRCODE",
            POS_LDEAL_INFO:"POS_LDEAL_INFO",
            POS_UM_INFO:"POS_UM_INFO",
            POS_GET_USER_DRAW_MONEY_INFO:"POS_GET_USER_DRAW_MONEY_INFO",
            NEW_INTERVIEW_FLAG:"POS_NEW_INTERVIEW_FLAG",
            PS_RATEDATE:"POS_PS_RATEDATE"
        },
        
        /**
         * iPOS图标点击事件
         * */
        initIpos : function() {
            var _this = this;
            //点击iPOS清除上次缓存的临时数据
            _this.clearLastData();
            //判断当前用户是否登录APP
            C.Native.isLogined(function(data) {
                if (data.flag == "1") {
                    _this.getCertId();
                } else {
                    C.Native.forwardModule({
                        module: 'ipos',
                        url: 'ipos_index.html'
                    });
                }
            });
        },
        
        /**
         * 清除iPOS上次存储数据
         * */
        clearLastData: function() {
            var _this = this,
                keyjson = _this.Constant;
            $.each(keyjson, function(key, value) {
                if (key != "POS_FIRSTTIP" && key != "POS_ISRJTIP" && key != "POS_FIRSTFZTIP" && key != "USER_LOGIN_INFO" && key != "NEW_INTERVIEW_FLAG") {
                    C.Utils.data(_this.Constant[key], null);
                }
            })
        },

        /**
         * 看用户是否已填写身份证信息
         * */
        getCertId: function() {
            var _this = this;
            C.Native.getUserInfo(function(data) {
                C.Utils.data(_this.Constant.USER_LOGIN_INFO, null);
                _this.userdata = data;
                if (_this.userdata && _this.userdata.Id) {
                    C.Utils.data(_this.Constant.USER_LOGIN_INFO, data);
                    _this.queryState();
                } else {
                    C.Native.TDOnEvent({
                        eventId: "0111-点击进入iPOS贷",
                        eventLable: "011102-需要补录身份信息"
                    });
                    App.call("addUserInfo", function(res) {
                        if (res.code == "1") {
                            C.Native.getUserInfo(function(data) {
                                _this.userdata = data;
                                C.Utils.data(_this.Constant.USER_LOGIN_INFO, data)
                                _this.queryState();
                            });
                        }
                    })
                }
            });
        },
        /**
         * 查询iPOS申请资格
         * */
        queryState: function() {
            C.Native.getAppVersion(function (res) {
                if (App.IS_ANDROID && res.version>=430) {
                    C.Native.loadingBeginNew('', false);
                } else {
                    C.UI.loading();
                }
            });
            var _this = this,
                userdata = C.Utils.data(_this.Constant.USER_LOGIN_INFO);
            var paramData = {
                name: userdata.custName,
                id: userdata.Id,
                tel: userdata.mobile
            };
            $.ajax({
                url: C.Api.QUERY_APPLY_FLAG,
                type: "post",
                data: paramData,
                timeout: 20000,
                success: function(res) {
                    C.UI.stopLoading();
                    if (res.flag == "1" && res.data) {
                        if (res.data.applyFlag == "1") {
                            //可以申请（包含已有申请）
                            var param = {
                                userId: userdata.mobile
                            }
                            _this.queryApplyState(param);
                        } else if (res.data.applyFlag == "0") {
                            C.Utils.data(_this.Constant.POS_CAN_APPLY, "false");
                            $.ajax({
                                url: C.Api.QUERY_APPLY_STATE,
                                type: "post",
                                data: {},
                                success: function(res) {
                                    var data = res.data;
                                    if (data.lastSubProcessCode === 'RJ') {
                                        var jumpUrl = "";
                                        if(data.lastProcessCode == "IB"){
                                            jumpUrl = "fail.html?from=credit";
                                        }else if(data.lastProcessCode == "IG"){
                                            jumpUrl = "fail.html?from=credit";
                                        }else if(data.lastProcessCode == "IC" || data.lastProcessCode == "PK"){
                                            jumpUrl = "fail.html?from=calculation";
                                        }else if(data.lastProcessCode == "PC" || data.lastProcessCode == "PV" || data.lastProcessCode == "PS"){
                                            jumpUrl = "fail.html?from=get";
                                        }else{
                                            jumpUrl = "fail.html?from=calculation";
                                        }
                                        //因前面被拒不可申请
                                        C.Native.forwardModule({
                                            module: 'ipos',
                                            url: jumpUrl
                                        });
                                    }else if(data.acctInfo && data.acctInfo.accountStatus){
                                        C.Native.forwardModule({
                                            module: 'ipos',
                                            url: "get_my_account.html"
                                        });
                                    } else {
                                        //不可申请且没有之前申请状态
                                        C.Native.forwardModule({
                                            module: 'ipos',
                                            url: "credit_index_1.html"
                                        });
                                    }
                                }
                            })
                        } else {
                            //不可申请
                            C.Native.tip(res.data.resultMsg);
                        }
                    }
                },
                error: function (xhr, errorType, error) {
                    C.UI.stopLoading();
                    if (!navigator.onLine || errorType === 'timeout' || errorType ==='abort') {
                        C.Native.tip('网络连接有问题，请检查网络');
                    }
                }
            })
        },
        /**
         * 查询iPOS申请状态
         * */
        queryApplyState: function(param) {
            var _this = this;
            $.ajax({
                url: C.Api.QUERY_APPLY_STATE,
                type: "post",
                data: param,
                success: function(res) {
                    C.UI.stopLoading();
                    if (res.flag == "1" && res.data && res.data.resultCode == "1") {
                        var toUrl = "";
                        C.Utils.data(_this.Constant.SS_APPLY_NO, res.data.applyNo || "");
                        C.Utils.data(_this.Constant.POS_DRAWNO, res.data.drawNo || "");
                        if (res.data.acctInfo && res.data.acctInfo.acctNo) {
                            C.Utils.data(_this.Constant.POS_ACCTNO, res.data.acctInfo.acctNo || "");
                        }
                        C.Utils.data(_this.Constant.POS_CUST_TYPE, res.data.custType || "");
                        if(res.data.acctInfo && res.data.acctInfo.accountStatus && res.data.processCode === 'IU' && res.data.subProcessCode === 'IU'){
                            toUrl = "get_my_account.html"
                        }else{
                            if (res.data.processCode === 'IU' && res.data.subProcessCode === 'IU') {
                                toUrl = "credit_index_1.html"
                            } else if (res.data.processCode === 'II' && res.data.subProcessCode === 'II') {
                                toUrl = "credit_index_1.html"
                            } else if (res.data.processCode === 'IB' && res.data.subProcessCode === 'IB') {
                                toUrl = "credit_index_1.html"
                            } else if (res.data.processCode === 'IB' && res.data.subProcessCode === 'RJ') {
                                //pos机和营业执照三次查询失败
                                toUrl = "fail.html?from=credit"
                            } else if (res.data.processCode === 'IG' && res.data.subProcessCode === 'IG') {
                                toUrl = "credit_index_1.html"
                            } else if (res.data.processCode === 'IM' && res.data.subProcessCode === 'IM') {
                                C.Utils.data(_this.Constant.CREDIT_BUSINESS_RESULT, res.data.um || "")
                                toUrl = "credit_input_referee.html"
                            } else if (res.data.processCode === 'IC' && res.data.subProcessCode === 'IC') {
                                toUrl = "credit_amount_calculation.html"
                            } else if (res.data.processCode === 'IC' && res.data.subProcessCode === 'RJ') {
                                toUrl = "fail.html?from=calculation"
                            } else if (res.data.processCode === 'IR' && res.data.subProcessCode === 'IR') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PM' && res.data.subProcessCode === 'PM') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PK' && res.data.subProcessCode === 'PK') {
                                toUrl = 'wait.html'
//                              toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PK' && res.data.subProcessCode === 'RJ') {
                                toUrl = "fail.html?from=calculation"
                            } else if (res.data.processCode === 'PC' && res.data.subProcessCode === 'RJ') {
                                toUrl = "fail.html?from=calculation"
                            } else if (res.data.processCode === 'PC' && res.data.subProcessCode === 'PC') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PP' && res.data.subProcessCode === 'PP') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PV' && res.data.subProcessCode === 'PV') {
                                C.Utils.data(_this.Constant.NEW_INTERVIEW_FLAG, "pv")
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PI' && res.data.subProcessCode === 'PI') {
                                toUrl = "get_check_state.html"
                            } else if (res.data.processCode === 'PH' && res.data.subProcessCode === 'PH') {
                                //一期没有
                                toUrl = "";
                            } else if (res.data.processCode === 'PV' && res.data.subProcessCode === 'RJ') {
                                toUrl = "fail.html?from=get"
                            } else if (res.data.processCode === 'PL' && res.data.subProcessCode === 'PL') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PS' && res.data.subProcessCode === 'PS') {
                                toUrl = "get_my_account.html"
                            } else if (res.data.processCode === 'PS' && res.data.subProcessCode === 'RJ') {
                                toUrl = "fail.html?from=get"
                            } else if (res.data.processCode === 'PR' && res.data.subProcessCode === 'PR') {
                                toUrl = "get_my_account.html"
                            } else {
                                //非正常状态提示
                                C.Native.tip(res.data.resultMsg)
                                return false;
                            }
                        }
                        if (toUrl) {
                            C.Native.TDOnEvent({
                                eventId: "0111-点击进入iPOS贷",
                                eventLable: "011101-点击进入iPOS贷"
                            });
                            C.Native.forwardModule({
                                module: 'ipos',
                                url: toUrl
                            });
                        }
                    } else {
                        //非正常状态提示
                        C.Native.tip(res.data.resultMsg)
                    }
                }
            })
        }
        
    };
    return iPOS;
});