/*!
 * register注册页
 * 处理注册及注册逻辑
 * @author 宋文 
 * @history 2015-11-30 add
 */
define(["zepto","C"],function($,C){
	//验证登陆信息
	'use strict';
	$(function(){
		C.UI.stopLoading();
	});

	var deviceInfo;
	var tmx_sessionId='';

	//TODO 增加TMX native调用
	C.Native.getTMXSessionId(function(data){
		console.log(data);
		if(C.Flag.SUCCESS == data.code){
			tmx_sessionId = data.result.sessionId;
		}					
	});
	

	$('.unselect').on('click',function(){
		$(this).toggleClass('highlight');
	});

	$('#rg_xy').on('tap',function(){
		C.Native.forward({
			url:'register_app_clause.html'
		});
	});

	$('#epkg_xy').on('tap',function(){
		C.Native.forward({
			url:'register_paone_clause.html'
		});
	});

	$("#mobile").on("keyup",function(){
		var curval=$(this).val();
		if(curval.length>11){
			var subval=curval.substr(0,11);
			$(this).val(subval);
		}
	});

	$("#mobile").on("keyup",function(){
		var curval=$.trim($(this).val());
		$(this).val(curval);
	});

	$("#smsCode").on("keyup",function(){
		var curval=$.trim($(this).val());
		$(this).val(curval);
	});

	var getsmsCode;
	$('.box-vam').on('tap',getsmsCode=function(){

		$('.box-vam').off('tap');

		if(verMoblie()){
			if(deviceInfo) {
				clickGetCode();
			}
			else {
				 C.Native.getRegisterParams(function(data){
			       	if(C.Flag.SUCCESS == data.code){
			            C.Utils.data(C.Constant.DataKey.DEVICE_INFO,data.result);
			        } else {
			            C.Utils.data(C.Constant.DataKey.DEVICE_INFO, '');
			        }

			        deviceInfo= C.Utils.data(C.Constant.DataKey.DEVICE_INFO);

			        clickGetCode();
			    });
                
				// //TODO 增加TMX native调用
				// C.Native.getTMXSessionId(function(data){
					
				// 	console.log(data);
				// 	if(C.Flag.SUCCESS == data.code){
						
				// 		tmx_sessionId = data.result.sessionId;
				// 	}					
				// });
			}
		}
		else{
			$('.box-vam').on('tap', getsmsCode);
		}
	});

	var registerEve;
	$('#next_step').on('tap',registerEve=function(){
		$('#next_step').off('tap');

		if(!$('.unselect').hasClass('highlight')){
			C.Native.tip('请先阅读协议');
			$('#next_step').on('tap',registerEve);
		}
		else if(verifyInfo()){

			if(deviceInfo) {
				gotoRegister();
			}
			else {
				 C.Native.getRegisterParams(function(data){
			       	if(C.Flag.SUCCESS == data.code){
			            C.Utils.data(C.Constant.DataKey.DEVICE_INFO,data.result);
			        } else {
			            C.Utils.data(C.Constant.DataKey.DEVICE_INFO, '');
			        }

			        deviceInfo = C.Utils.data(C.Constant.DataKey.DEVICE_INFO);

			        gotoRegister();
			    });
			}	
		}
		else{
			$('#next_step').on('tap',registerEve);
		}
	});

	function clickGetCode() {
		if(!deviceInfo) {
			C.Native.tip('参数错误, 请重新进入注册页面');
			return false;
		}

		startTimer();

		var params= {
			'mobile':C.rsaEncrypt($('#mobile').val()),
			'machineSN':deviceInfo.machineSN,
			'os':deviceInfo.os,
			'_RSAVER':deviceInfo._RSAVER
			//加密
		};

		$.ajax({
			url:C.Api.VERTIFY_REGISTMOBILE,
			type:"post",
			data:params,
			async:false,
			success:function(data){
				if(data.flag=="1"){
					var param= {
						'smsType':'register',
						'mobile':C.rsaEncrypt($('#mobile').val()),
						'_RSAVER':deviceInfo._RSAVER
						//加密
					}
					$.ajax({
						url:C.Api.GET_SMSOTP,
						type:"post",
						data:param,
						async:false,
						success:function(response){
							if(response.flag!=1){
								clearTimer();
								$('.box-vam').html('获取验证码').removeClass('code-click');
		      					$('.box-vam').on('tap', getsmsCode);
							}
						}
					});
				}
				else{
					clearTimer();
					$('.box-vam').html('获取验证码').removeClass('code-click');
  					$('.box-vam').on('tap', getsmsCode);
				}
			}
		});
	}

	function gotoRegister() {
		if(!deviceInfo) {
			C.Native.tip('参数错误, 请重新进入注册页面');
			return false;
		}

		if(deviceInfo.mac==''||deviceInfo.mac==null||deviceInfo.mac==undefined){
			deviceInfo.mac='';
		}else{
			deviceInfo.mac=deviceInfo.mac;
		}		

		if(deviceInfo.sim_mobile==''||deviceInfo.sim_mobile==null||deviceInfo.sim_mobile==undefined){
			deviceInfo.sim_mobile='';
		}else{
			deviceInfo.sim_mobile=deviceInfo.sim_mobile;
		}

		var RSAENCRYPT = new JSEncrypt();
		
		RSAENCRYPT.setPublicKey("-----BEGIN PUBLIC KEY-----\nMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDwHQU77tsMBNbKnzVd+OZeINs7\nrPgGdV8owrau1Ox9a5axrJ2nak3dDQiD9Zt/UfkckZhqFYhDmzxYOgkYDmoP4fTM\neqIwY4e0m4+WDTF6Ef74tEW2SeNwUVqBtcKD+DGEx9QTaWjOLu+wIw4f4gRuuro2\n7oSctyNJfiJ625C32QIDAQAB\n-----END PUBLIC KEY-----");
		
		var paramData = {
			'signVer':'Y',
			'mac':deviceInfo.mac,
			'platform':deviceInfo.platform,
			'machineSN':deviceInfo.machineSN,
			'isEmulator':deviceInfo.isEmulator,
			'lng':deviceInfo.lng,
			'lat':deviceInfo.lat,
			'city':deviceInfo.city,
			'mobileOsVer':deviceInfo.mobileOsVer,
			//'appVersion':deviceInfo.appVersion,
			'curVer':deviceInfo.appVersion,
			'sdkVersion':deviceInfo.sdkVersion,
			'sdkReturnStr':deviceInfo.sdkReturnStr,
			'mobileBrand':deviceInfo.mobileBrand,
			'address':deviceInfo.bdAddress,
			'sim_mobile':deviceInfo.sim_mobile,
			'_RSAVER':deviceInfo._RSAVER,
			'mobile':C.rsaEncrypt($('#mobile').val()),
			'key':C.rsaEncrypt($('#key').val()),
			'smsCode':C.rsaEncrypt($('#smsCode').val()),
			//TODO 增加sessionid
			'sessionId':tmx_sessionId
		};

		C.UI.loading();
        console.log(paramData);
		$.ajax({
			url:C.Api.CREATE_ACCOUNT,
			type:"post",
			data:paramData,
			async:false,
			success:function(res){
				C.UI.stopLoading();
				if(res && res.flag == C.Flag.SUCCESS){
                    C.Native.setUserInfo({
                    	'custName':res.data.custName,
                    	'account':res.data.account,
                    	'msgCnt':res.data.msgCnt,
                    	'token':res.data.token,
                    	'custId':res.data.custId,
                    	'mobile':res.data.mobile,
                    	'city':res.data.city,
                    	'cityName':res.data.cityName,
						'paPayToken':res.data.paPayToken,
						'accountId':res.data.accountId,
						'pointsSwitch':res.data.pointsSwitch,
						'ssoTicket':res.data.ssoTicket,
						'sessionSecret':res.data.sessionSecret,
						'mamcId':res.data.mamcId
                    });
                    C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO,res.data);
					$('#next_step').on('tap',registerEve);
                } else {
                	$('#next_step').on('tap',registerEve);	                    
                }		
			}
		});
	}

	function verifyInfo(){
		var delspace =  /\s+/g,
			replaceallnum=/\d+/g;
		var mobile=$.trim($('#mobile').val()).replace(delspace,""),
			smsCode=$.trim($('#smsCode').val()).replace(delspace,""),		
			key=$.trim($('#key').val()).replace(delspace,""),
			keynonum=$('#key').val().replace(replaceallnum,""),
			confirm_key=$.trim($('#confirm_key').val()).replace(delspace,"");

		if(mobile==null||mobile==""){
			C.Native.tip('请填写您的手机号码');
			return false;
		}
		else if(mobile&&!/^1[34587]\d{9}$/.test(mobile)){
			C.Native.tip('请正确填写您的手机号码');
			return false;
		}
		else if(smsCode==null||smsCode==""){
			C.Native.tip('请填写验证码');
			return false;
		}
		else if(smsCode&&!/^\d{7}$/.test(smsCode)){
			C.Native.tip('请填写正确的验证码');
			return false;
		}
		else if(key==null||key==""){
			C.Native.tip('请填写您的密码');
			return false;
		}
		else if(key&&!/^[A-Za-z0-9]{8,16}$/.test(key)){
			C.Native.tip('密码为8-16位数字和字母组合,且至少包含三个以上字母');
		}
		else if(key&&/^[A-Za-z]{8,16}$/.test(key)){
			C.Native.tip('密码为8-16位数字和字母组合,且至少包含三个以上字母');
		}
		else if(key&&/^[0-9]{8,16}$/.test(key)){
			C.Native.tip('密码为8-16位数字和字母组合,且至少包含三个以上字母');
		}		
		else if(keynonum.length<3){
			C.Native.tip('密码为8-16位数字和字母组合,且至少包含三个以上字母');
		}
		else if(confirm_key==null||confirm_key==""){
			C.Native.tip('请确认您的密码');
			return false;
		}		
		else if(key!=confirm_key){
			C.Native.tip('请保持您输入的密码和确认密码一致');
			return false;
		}
		else{
			return true;
		}
	}

	function verMoblie(){
		var delspace =  /\s+/g;
		var mobile=$.trim($('#mobile').val()).replace(delspace,"");
		if(mobile==null||mobile==""){
			C.Native.tip('请填写您的手机号码');
			return false;
		}
		else if(mobile&&!/^1[34587]\d{9}$/.test(mobile)){
			C.Native.tip('请正确填写您的手机号码');
			return false;
		}
		else{
			return true;
		}
	}

	function versmsCode(){
		var delspace =  /\s+/g;
		var smsCode=$.trim($('#smsCode').val()).replace(delspace,"");
		if(smsCode==null||smsCode==""){
			C.Native.tip('请填写验证码');
			return false;
		}
		else if(smsCode&&!/^\d{7}$/.test(smsCode)){
			C.Native.tip('请填写正确的验证码');
			return false;
		}
		else{
			return true;
		}
	}

	var timer;
	var sn = 60;

	function startTimer() {
		timer = setTimeout(function() {

			sn--;
			$('.box-vam').addClass('code-click');
			$('.box-vam').html('获取验证码<br />'+sn+'s');

			if(sn <= 0) {
				clearTimer();
			}
			else{
				startTimer();
			}

		}, 1000);
	}

	function clearTimer() {
		clearTimeout(timer);
		timer = null;
		$('.box-vam').html('重新获取').removeClass('code-click');
		$('.box-vam').on('tap', getsmsCode);
		sn=60;
	}

});