define(['zepto', 'C', 'view','js/component/identity'], function($, C, View, Identity) {
    'use strict';
    
    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .total-money': 'jumpTotalMoney',
            'tap .need-identity': 'needIdentity',
            'tap .no-papay': 'goBindPapay',
            'tap .total-profit': 'goHQB'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
            var self = this;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.MONEY_MAKE,
                leftCallback:function(){
                    C.Native.back();
                }
            });
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            
            C.Account.isLogin(function (data) {
                if (C.Flag.SUCCESS == data.flag) {
                    //判断是否补录身份证
                    if (!!self.userInfo.custId) {
                        //判断是否绑定平安付
                        if (!!self.userInfo.paPayToken) {
                            C.Native.getYiQianBaoBalance(function (res) {
                                if (C.Flag.SUCCESS == res.flag) {
                                    self.render(res.data);
                                }
                                C.UI.stopLoading();
                            });
                        } else {
                            var html = _.template($("#nopapay-tpl").html())();
                            self.$el.append(html);
                            self.$el.append(_.template($("#shop-tpl").html())());
                            C.UI.stopLoading();
                        }
                    } else {
                        var html = _.template($("#identity-tpl").html())();
                        self.$el.append(html);
                        self.$el.append(_.template($("#shop-tpl").html())());
                        C.UI.stopLoading();
                    }
                } else {
                    self.$el.append(_.template($("#shop-tpl").html())());
                    C.UI.stopLoading();
                }
                
            });
        },
        // 渲染整个view
        render: function (data) {
            var mainBalance = parseFloat(data.mainBalance.replace(/,/g, '')),
                hqBaoBalance = parseFloat(data.hqBaoBalance.replace(/,/g, ''));
            var total_money = mainBalance + hqBaoBalance;
            var html = _.template($('#content-tpl').html())({data:total_money});
            this.$el.append(html);
            this.$el.append(_.template($("#shop-tpl").html())());
            
        },
        jumpTotalMoney: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId:C.TD.Event.MAKE_MONEY_0801
            });
            C.Native.forward({
                url: 'assets.html'
            });
        },
        needIdentity: function () {
            var identity = new Identity({model:{callback:$$.EventListener.onRefresh}});
            $('body').append(identity.el);
        },
        goBindPapay: function () {
            C.Native.loginOrRegistPaOne(function () {
                $$.EventListener.onRefresh();
            });
        },
        goHQB: function () {
            //埋点
            C.Native.TDOnEvent({
                eventId:C.TD.Event.MAKE_MONEY_0802
            });
            var self = this;
            C.Native.updatePapayToken(self.userInfo.paPayToken,function(data){
                self.userInfo.paPayToken = data.paPayToken;
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, self.userInfo);
                C.Native.forward({
                    url: C.Constant.PAPAY_HQB_PAGE,
                    data: {access_token:self.userInfo.paPayToken}
                });
            });
        }
    }));

    $(function() {
        new Page();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function(data){
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                location.reload();
            });
        }
    });
});