define(['zepto', 'C', 'underscore', 'view'], function ($, C, _, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        el: 'body',
        events: {
            'tap .btn-shopping': 'goScoreShop',
            'tap .icon-close': "closeLeaayer"
        },
        // 实例化后默认初始化该方法
        initialize: function () {

            C.UI.loading();
            var self = this;
            //设置标题
            C.Native.setHeader({
                title: C.Constant.TITLE.MY_SCORE,
                leftCallback: function () {
                    C.Native.back();
                }
            });
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);


            $.ajax({
                type: "post",
                url: C.Api.MY_SCORE,
                success: function (res) {
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        // H5 url
                        self.wltUrl = res.data.wltUrl;
                        self.render(res.data);
                    }
                }
            });
        },
        // 渲染整个view
        render: function (data) {
            var html = _.template($('#content-tpl').html())({data: data.earnPointsList});
            this.$el.find('.my-score-total span').html(data.totalPoints || '0');
            this.$el.find('.my-score-list').html(html);
        },
        goScoreShop: function () {
             var self = this,
             mobile = self.userInfo.mobile;
             //埋点
             C.Native.TDOnEvent({
                eventId:C.TD.Event.SCORE_0602
             });
             C.Native.forward({
                url: C.Api.GO_WLT_SHOPING+'?merId='+ C.Constant.WLT_KEY+'&openId='+ mobile +'&mobile='+ mobile +'&callback='+ encodeURIComponent(self.wltUrl)
             });
        }
    }));

    $(function () {
        var myPage = new Page();
        $$.EventListener.onRefresh = function () {
            C.Native.getUserInfo(function (data) {
                C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO, data);
                myPage.initialize();
            });
        }
    });
});