/*!
 * 克拉分车险行驶证认证页面
 * @author 易征 
 * @history 2016-01-29 add
 */
define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        loginInfo:'',
        el:'body',
        timer:'',
        gap:'60000',//轮询查询接口时间
        custNo:'',
        events: {
            'tap .add-car': 'goAddAutoInsurance',
            'tap .auth-ins': 'goAuthorize',
            'tap .drivingLicense': 'goAuthorizeLicense',
            'tap .item-del' : 'delInsurance'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
             var self = this;
             //设置标题
              C.Native.setHeader({
                title: '车险认证',
                leftCallback: function () {
                    C.Native.back();
                }
            });
              self.loginInfo= C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
              if(!self.loginInfo){
                C.Native.getUserInfo(function(data){
                    self.loginInfo = data;
                });
            };
            //调用查询
            self.queryDataResult();
            //轮询查询接口
            /*self.timer = setInterval(function(){
                self.queryDataResult();
            },self.gap);*/
            self.move();
            C.UI.stopLoading();
        },
        // 渲染整个view
        render: function (data) {
            var obj = {
                data:data.caratAuthList,
                authDescription:this.authDescription
            };
            var HTML = _.template($('#insurance-contact-tpl').html())(obj);
            this.$el.find('.setting').html(HTML);
        },
        //认证状态描述
        authDescription: function(code){
            switch (code){
            case '0':
              return '绑定失败';
              break;
            case '1':
              return '绑定成功';
              break;
            case '2':
              return '认证中';
              break;
              case '3':
              return '未认证';
              break;
            case '-1':
              return '未认证';
              break;
            }
        },
        //添加车险
        goAddAutoInsurance: function (e) {
            var self = this;
            var num = parseInt($('.car-num').text());
            if(num<10){
                num +=1;
                $('.car-num').text(num+"份");
                var html = '<li><div class="item auth-ins itemNew"><div class="setting-text" data-type="policy_car" data-status="-1">未认证</div><div class="setting-list"><div class="text">车险保单'+num+'</div></div><div class="icon-right"></div></div><div class="item-del">删除</div></li>';
                $('.add-car').parent().parent().append(html);
            }
            self.move();
        },
        //去认证车险
        goAuthorize: function (e) {
            var self = this;
            //clearInterval(self.timer);
            //大数据认证页面点击X返回不能自动刷新
            /*self.timer = setInterval(function(){
                self.queryDataResult();
            },self.gap);*/
            var $target = $(e.currentTarget).find('.setting-text'),
                str = $(e.currentTarget).find('.text').text(),
                num = parseInt(str.substring(4))+1,
                status = $target.attr('data-status'),
                type = $target.attr('data-type');
            //埋点    
            if(num<10){
                num = '0'+num;
            }  
            C.Native.TDOnEvent({
                eventId: C.TD.Event.POLICY_CAR_090306,
                eventLable: C.TD.Label.POLICY_CAR_090306+num,
                });            
            if(status!="1"&&status!="2"){
                self.bindInsuranceAccount(type,$target);
            }
        },
        //去认证行驶证
        goAuthorizeLicense: function(){
            //埋点
            C.Native.TDOnEvent({
                eventId: C.TD.Event.POLICY_CAR_090306,
                eventLable: C.TD.Label.POLICY_CAR_09030601,
                });
        },
        //点击删除保险按钮
        delInsurance : function(e){
            var 
                $target = $(e.currentTarget).parent(),
                num = $target.parent().children('li').length-1,
                status = $target.find('.setting-text').attr('data-status'),
                text = $target.find(".text").text().substring(0,4);
            if(status!='1'&&status!='2'){
                num--;
                $target.siblings().find('.num').text(num+'份');
                $target.remove();
                for(var i=0;i<num;i++){
                   	var  newnum = i+1;
                    $(".add-car-ul > li").eq(i+1).find(".text").text(text+newnum);                  
                }           
            }else{
                C.Native.tip('该保险已经绑定成功,不能删除!');
                $target.animate({
                transform:'translateX(0rem)',
                '-webkit-transform':'translateX(0rem)',
                }, 30);
                $target.siblings('.item-del').hide(30);
            }

        },
        //左滑显示删除按钮
        showDel : function(e){
            var $target = $(e.currentTarget);
            $target.animate({
                transform:'translateX(-1rem)',
                '-webkit-transform':'translateX(-1rem)',
            }, 30)
            $target.siblings('.item-del').show(30);
        },
        //右滑隐藏删除按钮
        hideDel : function(e){
            var $target = $(e.currentTarget);
            $target.animate({
                transform:'translateX(0rem)',
                '-webkit-transform':'translateX(0rem)',
            }, 30)
            $target.siblings('.item-del').hide(30);
        },
        //去认证保险，调用native接口
        bindInsuranceAccount: function(netAccountType,$target) {
            var self = this;
            C.Native.bindInsuranceAccount(netAccountType,self.custNo,function(res){
                if(res&&res.code){
                	$target.attr('data-status','2');
                    $target.text('认证中');
                    clearInterval(self.timer);
                    self.timer = setInterval(function(){
                        self.queryDataResult();
                    },self.gap);
                    var netAccount=res.result.account;
                    var param = {
                            accountId:self.loginInfo.accountId,
                            loanCode:'carat',
                            authCode: res.result.accountType||netAccountType,
                            code: res.result.code,
                            netAccountNo:netAccount.split('&')[0]
                        };
                    self.commitBindAccount(param);
                }
            });
        },
        //提交认证数据
        commitBindAccount: function(param) {
            $.ajax({
                type:"post",
                url:C.Api.SUBMIT_CREDIT_AUTH,
                data:param,
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.data.resultCode) {
                        //C.Native.tip('提交成功');
                    }else {
                        //C.Native.tip('提交失败');
                    }
                },
                error: function (e) {
                        console.log(e);
                    }
            });
            C.UI.stopLoading();
        },
        //实现左滑右滑
        move :function(e){
            var count=0,startPosition, endPosition, deltaX, deltaY, isScrolling,self=this;  
            $(".item.itemNew").on('touchstart', function(e){
                count=0;
                var touch = e.touches[0];  
                startPosition = {  
                    x: touch.pageX,  
                    y: touch.pageY  
                }
            }) .on('touchmove', function(e){
                if(count==0){
                    var touch = e.touches[0];  
                    endPosition = {  
                        x: touch.pageX,  
                        y: touch.pageY  
                    };  
      
                    deltaX = endPosition.x - startPosition.x;  
                    deltaY = endPosition.y - startPosition.y;  
                    isScrolling = Math.abs(deltaX) < Math.abs(deltaY) ? 1:0; 
                    if(isScrolling===0){
                        e.preventDefault();
                    }
                }
                count++;
            }).on('touchend', function(e){
                    if(isScrolling === 0){//水平滑动 
                        if(deltaX <-8) { // 向左划动 
                            self.showDel(e);
                        } else if (deltaX >8) { // 向右划动 
                            self.hideDel(e);
                        }
                    }                      
            });
 
        },
        //查询接口
        queryDataResult : function(){
            var self = this;
            $.ajax({
                type:"post",
                url:C.Api.GAS_STATION,
                data:{
                    accountId:self.loginInfo.accountId,
                    queryType:'carat'
                },
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        var data =res.data;
                        self.custNo = data.custNo;
                        self.render(data);
                        var caratAuthList = data.caratAuthList;
                        var str = JSON.stringify(caratAuthList);
                        if(str.indexOf("policy_car")>-1){
                            $('.add-car-ul').show();
                        }else{
                            $('.add-car-ul').hide();
                        }
                    }
                },
                error: function (e) {
                    console.log(e);
                }
            });
        }
    }));

    $(function() {
        var insurancePage = new Page();
    });
});