/*!
 * 克拉分寿险认证页面
 * @author 易征 
 * @history 2016-01-29 add
 */
define(['zepto', 'C', 'view','swiper'], function($, C, View,Swiper) {
    'use strict';
    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        loginInfo:'',
        el:'body',
        timer:'',
        result:'',
        gap:'60000',//轮询查询接口时间
        custNo:'',
        authsStaus:'',
        netAccountNo:'',
        accountType:'',
        authStatus:'',
        photoCodes:'',
        caratList:[],
        storage:[],
        eqq:'',
        allattr:[],
        data_status:'',
        photoLimitedNumber:'',
        isTrue:true,
        oNum:0,
        olHeight:'',
        oVal:'',
        lifeData:{
            pay:'',
            insurance:'',
            date:'',
            money:'',
        },

        events: {
            'tap .add-life': 'goAddLifeInsurance',
            'tap .go_authorize': 'goAuthorize',
            'tap .item-del' : 'delInsurance',
            'tap .sumbit_s' : 'isSubmit',
            'tap .add_picture':'addPicture'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
             var self = this;
                 self.eqq=C.Utils.getParameter('eqq');
                 self.data_status=C.Utils.getParameter('data_status');
                 self.netAccountNo = C.Utils.getParameter('id');

                 if(!self.netAccountNo && self.netAccountNo == 'null') {
                    self.netAccountNo = '';
                 }

             //设置标题
              C.Native.setHeader({
                title:C.Constant.TITLE.POLICY_LIFE + self.eqq ,
                leftCallback: function () {
                    C.Native.back();
                }
            });
              self.olHeight=$(window).height();
              self.loginInfo= C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
              if(!self.loginInfo){
                C.Native.getUserInfo(function(data){
                    self.loginInfo = data;
                });
            };
            if(self.data_status!='1'){
                C.Utils.data(C.Constant.DataKey.POLICY_DATA,'');
            }
            var tmpData = C.Utils.data(C.Constant.DataKey.POLICY_DATA);
            if(tmpData) {
                self.lifeData = tmpData;
                if(self.lifeData.pay!='null'){
                    $('.longevity_list li').eq(1).find('.select-text').html(self.lifeData.pay);
                }
                if(self.lifeData.insurance!='null'){
                    $('.longevity_list li').eq(2).find('.select-text').html(self.lifeData.insurance);
                }
                if(self.lifeData.date!='null'){
                    $('.longevity_list li').eq(3).find('input').val(self.lifeData.date)
                }
                if(self.lifeData.money!='null'){
                    $('.longevity_list li').eq(4).find('input').val(self.lifeData.money)
                }
            }

            $("#big_tar").on("keyup",function(){
                var curval=$(this).val();
                    if(!/\d{1,8}([\.]\d{2})?/.test(curval)){
                        var subval=curval.substr(0,curval.length-1);
                        $(this).val(subval);
                        return;
                    }else if(curval.length>11){
                        $(this).val(curval.substr(0,11));
                        return;
                    }
                C.Utils.data(C.Constant.DataKey.POLICY_DATA,self.money);
            });
            $('.longevity_list li').eq(4).find('input').attr('disabled','true');
            self.olHeight=$(window).height();
            self.buttonPosition();

            //self.inputOnfocus();
            //拍照调用
            self.tapPhoto();
            self.tapPhoto2();
            //self.removePhoto();
           // $(document).height($(window).height());true
            //下拉显示调用
            self.selectShow();
            self.inputOne();
            self.inputOnblur();
            //调用查询
            self.queryDataResult();
            //轮询查询接口
            /*self.timer = setInterval(function(){
                self.queryDataResult();
            },10000);*/
            //C.UI.stopLoading();
            $('.longevity_list li').eq(4).find('input').removeAttr('disabled');
        },
        // 渲染整个view
        render: function (data) {
            var self=this;
            var caratAuthList=data.caratAuthList;
        },
        //认证状态描述
        authDescription: function(code){
            switch (code){
                case '0':
                  return '绑定失败';
                  break;
                case '1':
                  return '绑定成功';
                  break;
                case '2':
                  return '认证中';
                  break;
                  case '3':
                  return '未认证';
                  break;
                case '-1':
                  return '未认证';
                  break;
            }
        },
        //去认证
        goAuthorize: function (e) {
            var self = this;
            if(self.data_status!='1'&&self.data_status!='2'){
                C.Native.bindInsuranceAccount('policy_life',self.custNo,function(res){
                if(res&&res.code){
                    $('.longevity_list li').eq(0).find('.icon-right').html('认证中');
                    self.data_status=2;
                    //$target.text('认证中');
                    self.result=res.result;
                    var netAccount=res.result.account;
                        self.netAccountNo=netAccount;
                        if(res.result.accountType=='1'||res.result.accountType=='2'){
                            self.data_status=res.result.accountType;
                        }
                    var param2 = {
                            accountId:self.loginInfo.accountId,
                            loanCode:'carat',
                            authCode: res.result.accountType||netAccountType,
                            code: res.result.code,
                            netAccountNo:netAccount//.split('&')[0]
                        };
                     $.ajax({
                        type:"post",
                        url:C.Api.SUBMIT_CREDIT_AUTH,
                        data:param2,
                        success:function(res){
                            self.queryDataResult();
                        }
                    });
                    C.UI.stopLoading();
                    }
                });
            }
             
        },
        //查询加油站列表接口
        queryDataResult : function(){
            var self = this;
            C.UI.loading();
            $.ajax({
                type:"post",
                url:C.Api.GAS_STATION,
                data:{
                    accountId:self.loginInfo.accountId,
                    queryType:'carat'
                },
                success:function(res){
                 var res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag&&res.data.resultCode=='1') {
                        var data =res.data;
                        $('.longevity_list li').eq(0).find('.icon-right').html(self.authDescription(self.data_status));
                        self.custNo=data.custNo;
                        //self.addPicture();
                        if(self.data_status=='1'||self.data_status=='2'){
                            self.render(data);
                            self.detailedInformation();
                        }
                    }
                }
            });
        },
        //查询加油站详细信息接口
        detailedInformation:function(){
            var self = this;
            C.UI.loading();
            $.ajax({
                type:"post",
                url:C.Api.DETAILED_INFORMATION,
                data:{
                    custNo:self.custNo,
                    ssAccountId:self.loginInfo.accountId,
                    loanCode:'carat',
                    authCode:self.accountType||'policy_life',
                    netAccountNo:self.netAccountNo
                },
                success:function(res){
                 var res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        self.storage = [];
                        var aHtml='';
                        self.photoLimitedNumber=res.data.photoLimitedNumber;
                        if(res.data.photoCodes!='null'&&res.data.photoCodes!=''){
                            var tRes=res.data.photoCodes.split(',');
                            for(var i=0;i<tRes.length;i++){
                               aHtml+='<div class="photo2">'
                                    +'<img class="photoimg" src="">'
                                +'</div>'
                                self.storage.push(tRes[i]);
                            }
                            $('.add_to').html(aHtml);
                            self.tapPhoto();
                            self.photoCodes=res.data.photoCodes;
                        }
                        if(res.data.paymentMethod&&res.data.paymentMethod!='null'&&res.data.paymentMethod!=''){
                            $('.longevity_list li').eq(1).find('.select-text').html(res.data.paymentMethod)
                        }else if(!self.lifeData || !self.lifeData.pay || self.lifeData.pay == ''){
                            $('.longevity_list li').eq(1).find('.select-text').html('缴费方式')
                        }
                        if(res.data.riskName&&res.data.riskName!='null'&&res.data.riskName!=''){
                            $('.longevity_list li').eq(2).find('.select-text').html(res.data.riskName);
                        }else if(!self.lifeData || !self.lifeData.insurance || self.lifeData.insurance == ''){
                            $('.longevity_list li').eq(2).find('.select-text').html('险种');
                        }
                        if(res.data.policyEffectDate!='null'){
                            $('.longevity_list li').eq(3).find('input').val(res.data.policyEffectDate);
                        }
                        if(res.data.amountPerPolicyPerPay&&res.data.amountPerPolicyPerPay!='null'&&res.data.amountPerPolicyPerPay!=''){
                            $('.longevity_list li').eq(4).find('input').val(res.data.amountPerPolicyPerPay);
                        }
                        if(self.data_status=='1'||self.data_status=='2'){
                            //获取图片接口调用
                            if(self.photoCodes&&self.photoCodes!='null'){
                                self.fileGetter();
                                self.olHeight=$(window).height();
                                self.buttonPosition();
                            }
                        }
                    }
                }
            });
        },
        //点击增加拍照
        addPicture:function () {
            var self= this;
                
            if(self.data_status=='1'||self.data_status=='2') {
                if(self.photoLimitedNumber>0) {
                    if($('.photo').length=='0'){
                        var Html='<div class="photo">'
                            +'<div class="icon-pt"></div>'
                            +'<img src="" style="display:none">'
                            +'</div>'
                            $('.longevity_list .add_to').append(Html);
                    }
                    //拍照调用
                    self.tapPhoto();
                } else if(self.photoLimitedNumber==0 || self.photoLimitedNumber=='null') {
                    C.Native.tip('您最多可以上传20张照片');
                } 
            } else {
                C.Native.tip('请先认证寿险保单');
            }
         },
        //是否可以提交信息
        isSubmit: function(){
            var self= this;
            if(self.data_status=='1'||self.data_status=='2'){
                    if($('.longevity_list li').eq(1).find('.select-text').html()=='缴费方式'||$('.longevity_list li').eq(1).find('.select-text').html()=='请选择缴费方式'||$('.longevity_list li').eq(1).find('.select-text').html()==''){
                        C.Native.tip('请选择缴费方式');
                        return;
                    }
                    if($('.longevity_list li').eq(2).find('.select-text').html()=='险种'||$('.longevity_list li').eq(2).find('.select-text').html()=='请选择险种'||$('.longevity_list li').eq(2).find('.select-text').html()==''){
                        C.Native.tip('请选择险种');
                        return;
                    }
                    if($('.longevity_list li').eq(3).find('input').val()==''){
                        C.Native.tip('请选择日期');
                        return;
                    }
                    if(self.oVal==''){
                        C.Native.tip('金额输入不正确，请重新输入');
                        return;
                    }
                    self.commitBindAccount();
                   // C.Native.tip('提交成功');
            }else{
                C.Native.tip('请先认证寿险保单');
            }
        },
        //提交认证数据
        commitBindAccount: function() {
            var self = this;
            var param = {
                    ssAccountId:self.loginInfo.accountId,
                    loanCode:'carat',
                    authCode:'policy_life',
                    code: self.result.code,
                    netAccountNo:self.netAccountNo,//self.result.account.split('&')[0],
                    childCommitType:'policyInfos',
                    paymentMethod:$('.longevity_list li').eq(1).find('.select-text').text(),
                    riskName:$('.longevity_list li').eq(2).find('.select-text').text(),
                    policyEffectDate:$('.longevity_list li').eq(3).find('input').val(),
                    //policyCopies:$('.longevity_list li').eq(4).find('input').val(),
                    amountPerPolicyPerPay:$('.longevity_list li').eq(4).find('input').val(),
                    //photoCodes:'',
                    //photoLimitedNumber:'20'
            };
            $.ajax({
                type:"post",
                url:C.Api.SUBMIT_CREDIT_AUTH,
                data:param,
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    C.Utils.data(C.Constant.DataKey.POLICY_DATA,'');
                    if (C.Flag.SUCCESS == res.data.resultCode) {
                        C.Native.tip(res.data.resultMsg);
                    }else {
                        //C.Native.tip('提交失败');
                    }
                },
                error: function (e) {
                    }
            });
        },
        //图片获取接口
        fileGetter :function(){
            var self = this;
            C.UI.loading();
            $.ajax({
                type:"post",
                url:C.Api.FILE_GETTER,
                data:{
                    accountId:self.loginInfo.accountId,
                    fileIds:self.photoCodes
                },
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    //C.UI.stopLoading();
                    //var aHtml='';
                    if (res.flag=='1') {
                        var imgHtml='';
                        for(var i=0;i<self.storage.length;i++){
                            if(self.storage[i]){
                                $('.photo2 img').eq(i).attr('src',res.data[self.storage[i]]);
                            }
                        }

                        //$('.add_to').html(aHtml);
                        for(var i=0;i<$('.photo2').length;i++){
                            imgHtml+='<div class="swiper-slide"><img src="'+$('.photo2').eq(i).find('img').attr('src')+'"></div>'
                        }
                        $('.swiper-container .swiper-wrapper').html(imgHtml);
                        self.olHeight=$(window).height();
                        self.buttonPosition();
                        self.inputOnblur();
                        self.tapPhoto2();
                        self.removePhoto();
                        C.UI.stopLoading();
                        $('.longevity_list li').eq(4).find('input').removeAttr('disabled');
                    }
                }
            });
        },
        //点击上传照片
        tapPhoto:function(){
            var self= this;
            $('.photo').off('tap').on('tap',function(){
                if(self.data_status=='1'||self.data_status=='2'){
                    self.nsurancePhoto();
                   // C.Native.tip('提交成功');
                }else{
                C.Native.tip('请先认证寿险保单');
            }
            });

        },
        //提交按钮位置1
        buttonPosition:function(){
            var self= this;
            //var htop=$('html').height();
            var hsumbit_s=$('.sumbit_s').height();
            var zHeight=self.olHeight-hsumbit_s;
            $('.fixed2 .sumbit_s').css({
                position:'fixed',
                left:0,
                top:zHeight,
                width:'100%'
            });
        },
        //寿险拍照接口
        nsurancePhoto: function(){
            var self = this;
            C.Native.nsurancePhotograph(self.netAccountNo, self.photoLimitedNumber ,self.loginInfo.accountId,'policy_life', function(res){
                    if(res.code&&res.code=='1'){
                        //alert(JSON.siringify(res));
                            self.queryDataResult();
                            //获取图片接口调用

                            //self.fileGetter();
                            self.tapPhoto2();
                            //self.removePhoto();
                            if($('.photo').length=='0'){
                                $('.add_picture').removeAttr('disabled');
                            }
                    }
                });
        },
        //点击图片放大
        tapPhoto2: function(){
            var self= this;
            var  swiper;
            $('.photo2').off('tap');
            $('.photo2').tap(function(){
                var oLength=$(this).index();
                    $('.swiper-wrapper')[0].style.webkitTransform='translateX(-'+$('html').width()*oLength+'px)'
                    $('.bomb_box').show();
                    //swiper = new Swiper('.swiper-container');
                    //self.removePhoto();
                    C.Native.setHeader({
                        title:C.Constant.TITLE.POLICY_LIFE + self.eqq ,
                        leftCallback: function () {
                           $('.bomb_box').hide();
                           C.Native.setHeader({
                                title:C.Constant.TITLE.POLICY_LIFE + self.eqq ,
                                leftCallback: function () {
                                   C.Native.back();
                                }
                            });
                        }
                    });
            });
        },
        //点击放大的图片隐藏
        removePhoto:function(){
            var self=this;

            $('.bomb_box img').off('tap');
            $('.bomb_box img').tap(function(){
                //$('.swiper-wrapper')[0].style.webkitTransform='translateX(0px)';
                $('.bomb_box').hide();
            });
        },
        //下拉显示
        selectShow: function(){
            var self= this;
             $('.longevity_list li select').change(function() {
                $(this).parent().find('.select-text').html($(this).val());
                self.lifeData.pay=$('.longevity_list li').eq(1).find('.select-text').html();
                self.lifeData.insurance=$('.longevity_list li').eq(2).find('.select-text').html();
                C.Utils.data(C.Constant.DataKey.POLICY_DATA,self.lifeData);
            });
        },
        //存储保单信息到本地
        inputOne:function(){
            var self= this;
            $('.longevity_list li').eq(3).find('input').change(function(event) {
                self.lifeData.date=$(this).val();
                C.Utils.data(C.Constant.DataKey.POLICY_DATA,self.lifeData);
            });
             $('.longevity_list li').eq(4).find('input').change(function(event) {
                self.lifeData.money=$(this).val();
                C.Utils.data(C.Constant.DataKey.POLICY_DATA,self.lifeData);
                self.oVal=$(this).val();
            });
        },
        //
        /*inputTwo:function(){
            var self= this;
            $('.longevity_list li').eq(4).find('input').change(function(event) {
                self.allattr.push($(this).val());
                self.oVal=$(this).val();
            });
        },*/
        inputOnblur:function(){
            var self= this;
             $('#big_tar').on('blur',function(event) {
                self.oVal=$(this).val();
                //$('.sumbit_s').hide();
                //console.log($(window).height())
            });
        }
        /*big_tarfocus:function(){
            var self=this;
            $('#big_tar').on('focus',function(event) {
                //self.olHeight=$(window).height();
                var thisWheight=document.body.clientHeight;
                console.log(document.body.clientHeight)
                console.log(self.olHeight);
                
                //self.buttonPosition();

            });
        }*/
    }));

    $(function() {
        var insurancePage = new Page();
    });
});