/*!
 * 克拉分寿险认证页面
 * @author 易征 
 * @history 2016-01-29 add
 */
define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        loginInfo:'',
        el:'body',
        timer:'',
        gap:'60000',//轮询查询接口时间
        custNo:'',
        events: {
            'tap .add-life': 'goAddLifeInsurance',
            'tap .auth-ins': 'goDetail',//跳下级页面
            'tap .item-del' : 'delInsurance',
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
             var self = this;
             
             //设置标题
            C.Native.setHeader({
                title: "寿险认证",
                leftCallback: function () {
                    C.Native.back();
                }
            });
              self.loginInfo= C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
              if(!self.loginInfo){
                C.Native.getUserInfo(function(data){
                    self.loginInfo = data;
                });
            };
           //调用查询
            self.queryDataResult();
            //轮询查询接口
            /*self.timer = setInterval(function(){
                self.queryDataResult();
            },self.gap);*/
            self.move();
            //C.UI.stopLoading();
        },
        // 渲染整个view
        render: function (data) {
            var self=this;
            var obj = {
                data:data.caratAuthList,
                authDescription:this.authDescription
            };
            var html = _.template($('#insurance-contact-tpl').html())(obj);
            //console.log(html);
            this.$el.find('.setting').html(html);
            self.goInsurance();
        },
        //认证状态描述
        authDescription: function(code){
            switch (code){
            case '0':
              return '绑定失败';
              break;
            case '1':
              return '绑定成功';
              break;
            case '2':
              return '认证中';
              break;
              case '3':
              return '未认证';
              break;
            case '-1':
              return '未认证';
              break;
            }
        },
        //添加寿险
        goAddLifeInsurance: function (e) {
            var self = this;
            var num = parseInt($('.life-num').text());
            if(num<10){
                num +=1;
                $('.life-num').text(num+"份");
                var html = '<li Index='+num+' class="index_s"><div class="item auth-ins itemNew"><div class="setting-text" data-type="policy_life" data-status="-1">未认证</div><div class="setting-list"><div class="text">寿险保单'+num+'</div></div><div class="icon-right"></div></div><div class="item-del">删除</div></li>';
                $('.add-life').parent().parent().append(html);
            }
            self.goInsurance();
            self.move();
        },
        //保险详细页面
        goDetail: function (e) {
            var self = this;
            var num = parseInt($('.life-num').text());
            var $target = $(e.currentTarget).find('.setting-text'),
                str = $(e.currentTarget).find('.text').text(),
                num = str.substring(4),
                status = $target.attr('data-status'),
                type = $target.attr('data-type');
            //埋点    
            if(parseInt(num)<10){
                num = '0'+num;
            }
            C.Native.TDOnEvent({
                eventId: C.TD.Event.POLICY_CAR_090305,
                eventLable: C.TD.Label.POLICY_CAR_090305+num,
                });                 
        },
        //点击删除保险按钮
        delInsurance : function(e){
            var 
                $target = $(e.currentTarget).parent(),
                num = $target.parent().children('li').length-1,
                status = $target.find('.setting-text').attr('data-status'),
                text = $target.find(".text").text().substring(0,4);
            if(status!='1'&&status!='2'){
                num--;
                $target.siblings().find('.num').text(num+'份');
                $target.remove();
                for(var i=0;i<num;i++){
                   	var  newnum = i+1;
                   	$(".add-life-ul > li").eq(i+1).find(".text").text(text+newnum);                   
                }           
            }else{
                C.Native.tip('该保险已经绑定成功,不能删除!');
                $target.animate({
                transform:'translateX(0rem)',
                '-webkit-transform':'translateX(0rem)',
                }, 30);
                $target.siblings('.item-del').hide(30);
            }

        },
        //左滑显示删除按钮
        showDel : function(e){
            var $target = $(e.currentTarget);
            $target.animate({
                transform:'translateX(-1rem)',
                '-webkit-transform':'translateX(-1rem)',
            }, 30)
            $target.siblings('.item-del').show(30);
        },
        //右滑隐藏删除按钮
        hideDel : function(e){
            var $target = $(e.currentTarget);
            $target.animate({
                transform:'translateX(0rem)',
                '-webkit-transform':'translateX(0rem)',
            }, 30)
            $target.siblings('.item-del').hide(30);
        },
        //实现左滑右滑
        move :function(e){
            var self = this;
            var count=0,startPosition, endPosition, deltaX, deltaY, isScrolling,self=this;  
            $(".item.itemNew").on('touchstart', function(e){
                count=0;
                var touch = e.touches[0];  
                startPosition = {  
                    x: touch.pageX,  
                    y: touch.pageY  
                }
            }) .on('touchmove', function(e){
                if(count==0){
                    var touch = e.touches[0];  
                    endPosition = {  
                        x: touch.pageX,  
                        y: touch.pageY  
                    };  
      
                    deltaX = endPosition.x - startPosition.x;  
                    deltaY = endPosition.y - startPosition.y;  
                    isScrolling = Math.abs(deltaX) < Math.abs(deltaY) ? 1:0; 
                    if(isScrolling===0){
                        e.preventDefault();
                    }
                }
                count++;
            }).on('touchend', function(e){
                    if(isScrolling === 0){//水平滑动 
                        if(deltaX <-8) { // 向左划动 
                            self.showDel(e);
                        } else if (deltaX >8) { // 向右划动 
                            self.hideDel(e);
                        }
                    }                      
            });
 
        },
        //跳转寿险详细认证页面
        goInsurance:function(){
            $('.index_s .item').off('tap').on('tap',function(){
                var this_index=$(this).parent('li').attr("Index");
                var data_status=$(this).find('.setting-text').attr('data-status');
                var data_id=$(this).find('.setting-text').attr('data-id');
                    C.Native.forward({
                        url: 'policy-life-detail.html?eqq='+this_index+'&data_status='+data_status+'&id='+data_id,
                        data:{
                            eqq:this_index
                        }
                    });
            })
        },
        //查询接口
        queryDataResult : function(){
            var self = this;
            $.ajax({
                type:"post",
                url:C.Api.GAS_STATION,
                data:{
                    accountId:self.loginInfo.accountId,
                    queryType:'carat'
                },
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        console.log(res)
                        var data =res.data;
                        self.custNo = data.custNo;
                        self.render(data);
                        var caratAuthList = data.caratAuthList;
                        var str = JSON.stringify(caratAuthList);
                        if(str.indexOf("policy_life")>-1){
                            $('.add-life-ul').show();
                        }else{
                            $('.add-life-ul').hide();
                        }

                        for(var i=0;i<caratAuthList.length;i++){
                            if(caratAuthList[i].authCode=='policy_life'){
                               $('.setting-text').eq(i).html(self.authDescription(caratAuthList[i].authStatus))
                            }
                            
                        }
                    }
                },
                error: function (e) {
                   //console.log(e);
                }
            });
        }
    }));

    $(function() {
        var insurancePage = new Page();

        $$.EventListener.onBack = function () {
            C.UI.loading();
            //location.reload();

            insurancePage.queryDataResult();
            for(var i=0; i<$('.credit-info ul li').length;i++){
                if($('.credit-info ul li').eq(i).attr('data_status')!='1'&&$('.credit-info ul li').eq(i).attr('data_status')!='-1'&&$('.credit-info ul li').eq(i).attr('data_status')!='3'){
                    $('.credit-info ul li').eq(i).find('.setting-text').html('认证中');
                }
            }

            //C.UI.stopLoading();
        }
    });

    
});