define(['zepto', 'C', 'view','js/iloan'], function($, C, View, L) {
    'use strict';
    
    var Page = View.extend(_.extend({
        tagName: 'section',
        className: 'repayment-list',
        events: {
            //'tap .xbyd,.idai,.fdyd': 'goILoan',
            'tap .xbyd,.fdyd': 'goXindai',            
            'tap .zed-more':'goZedApplyRecord',
            'tap .idai': 'goILoan',
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            var self = this;
            //当前页面需3个请求
            self.steps = 3;
            //设置标题
            C.Native.setHeader({
                title:C.Constant.TITLE.REPAYMENT_LIST
            });
            
            //获取用户信息
            self.userInfo = C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
            
            self.getData();
        },
        // 渲染整个view
        render: function (data) {
            var html = _.template($("#content-tpl").html())({data : data});
            $('.question').html(html);
        },
	    showXBFDData: function (data) {
            var html = _.template($("#xb-content-tpl").html())({data : data});
            $('.question').html(html);
        },
        stopLoading: function () {
            this.steps--;
            if (this.steps <= 0) {
                C.UI.stopLoading();
            }
        },
        getData: function () {
            var self = this;

            //读取网销产品数据，iloan
            var WXBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_WX_BORROW_MONEY);

            if(!!WXBorrowMoney) {
                var list = self.getWXData(WXBorrowMoney);
                if (list.length > 0) {
                    self.render(list);
                }
                self.stopLoading();
            } else {
                //没有存缓存
                $.ajax({
                    type:"get",
                    url:C.Api.QUERY_USERAPPLY_STATE,
                    data:{"_SEARCHSUMMARYINFOVER":"2.0"},
                    success:function(res){
                        if (C.Flag.SUCCESS == res.flag) {
                            var list = self.getWXData(res.data);
                            if (list.length > 0) {
                                self.render(list);
                            }
                        }
                        self.stopLoading();
                    },
                    error:function(res) {
                        self.stopLoading();
                    }
                });
            }

            //读取信保产品数据
            var XBBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_XB_BORROW_MONEY);

            if (!!XBBorrowMoney) {
                var list = self.getXBFDData(XBBorrowMoney);
                if (list.length > 0) {
                    self.showXBFDData(list);
                } 
                self.stopLoading();
            } else {
                $.ajax({
                    type:"get",
                    url:C.Api.QUERY_XBLOAN_INFO,
                    data:{"_SEARCHSUMMARYINFOVER":"2.0"},
                    success:function(res){
                        if (C.Flag.SUCCESS == res.flag) {
                            var list = self.getXBFDData(res.data);
                            if (list.length > 0) {
                                self.showXBFDData(list);
                            }
                        }
                        self.stopLoading();
                    },
                    error:function(res) {
                        self.stopLoading();
                    }
                });
            }

            //获取宅e贷借款数据
            var zedBorrowMoney = C.Utils.data(C.Constant.DataKey.HOME_ZED_BORROW_MONEY);
            if (!!zedBorrowMoney) {
                self.getZedData(zedBorrowMoney);
                self.stopLoading();
            } else {
                var identifyId = self.userInfo.Id || self.userInfo.id;
                $.ajax({
                    type:"get",
                    url:C.Api.QUERY_ZED_APPLY_RECORD,
                    data:{
                        certId : identifyId || "",
                        clientNo : self.userInfo.accountId,
                        clientModel : "YD"
                    },
                    success:function(res){
                        if (res && res.flag==C.Flag.SUCCESS) {
                            if (res.data && res.data.applyMap) {
                                self.getZedData(res.data.applyMap);
                            }
                        }
                        self.stopLoading();
                    },
                    error: function () {
                        self.stopLoading();
                    }
                });
            }
        },

        /* getBorrowData: function (data) {
            var self = this;
            var obj = C.operBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'RP' || item.status == 'OD') {
                    return true;
                } else {
                    return false;
                }
            });
            return obj.borrowList;
        },  */
	
	    getWXData: function (data) {
            var self = this;
            var obj = C.operWXBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'RP' || item.status == 'OD') {
                    return true;
                } else {
                    return false;
                }
            });
            return obj.borrowList;
        },

        getXBFDData: function (data) {
            var self = this;
            var obj = C.operXBFDBorrowData(data);

            obj.borrowList = obj.borrowList.filter(function (item) {
                if (item.status == 'RP' || item.status == 'OD') {
                    return true;
                } else {
                    return false;
                }
            });
            return obj.borrowList;
        },
	
	
        getZedData: function (applyMap) {
            var self = this;
            
            var applyList = C.operZedData(applyMap);
            //只选取可还款状态的
            applyList = applyList.filter(function (item) {
                if ($.inArray(item.statusCode,[8,10,12]) > -1) {
                    return true;
                } else {
                    return false;
                }
            });

            if (applyList.length >= 1) {
                self.showZedData();
            }
        },
        showZedData: function () {
            var html = _.template($("#zed-content-tpl").html())();
            $('.repayment-list').append(html);
        },
        /*goILoan: function () {
            C.Native.gotoNative('iLoan');
        },*/


        goIloan: function() {
            L.goIloan();
        },

        goXindai: function() {
            L.goXindai();
        },

        goZedApplyRecord: function () {
            C.Native.forwardModule({
                module: 'zed',
                url: 'apply_record.html'
            });
        }
    }));

    $(function() {
        new Page({
            el:$("body")[0]
        });
    });
});