/*!
 * 克拉分社保公积金认证页面
 * @author 易征 
 * @history 2016-01-29 add
 */
define(['zepto', 'C', 'view'], function($, C, View) {
    'use strict';

    var Page = View.extend(_.extend({
        tagName: '',
        className: '',
        loginInfo:'',
        el:'body',
        timer:'',
        gap:'60000',//轮询查询接口时间
        custNo:'',
        events: {
        	'tap .auth-ins': 'goAuthorize'
        },
        // 实例化后默认初始化该方法
        initialize: function () {
            C.UI.loading();
             var self = this;
             //设置标题
              C.Native.setHeader({
                title: C.Constant.TITLE.SOCIAL_PROVIDENT,
                leftCallback: function () {
                    C.Native.back();
                }
            });
              self.loginInfo= C.Utils.data(C.Constant.DataKey.USER_LOGIN_INFO);
              if(!self.loginInfo){
                C.Native.getUserInfo(function(data){
                    self.loginInfo = data;
                });
            };
            //调用查询
            self.queryDataResult();
            //轮询查询接口
            self.timer = setInterval(function(){
                self.queryDataResult();
            },self.gap);
            C.UI.stopLoading();
        },
        // 渲染整个view
        render: function (data) {
            var obj = {
                data:data.caratAuthList,
                authDescription:this.authDescription
            };
            var html = _.template($('#insurance-contact-tpl').html())(obj);
            this.$el.find('.setting').html(html);
        },
        //认证状态描述
        authDescription: function(code){
            switch (code){
            case '0':
              return '绑定失败';
              break;
            case '1':
              return '绑定成功';
              break;
            case '2':
              return '认证中';
              break;
              case '3':
              return '未认证';
              break;
            case '-1':
              return '未认证';
              break;
            }
        },
        //去认证
        goAuthorize: function (e) {
            var self = this;
            clearInterval(self.timer);
            var $target = $(e.currentTarget).find('.setting-text'),
                status = $target.attr('data-status'),
                type = $target.attr('data-type');
            if(status!="1"&&status!="2"){
                self.bindInsuranceAccount(type,$target);
            }
        },
        //去认证保险，调用native接口
        bindInsuranceAccount: function(netAccountType,$target) {
            var self = this;
            C.Native.bindInsuranceAccount(netAccountType,self.custNo,function(res){
                if(res&&res.code){
                    $target.attr('data-status',res.code);
                    $target.text('认证中');
                    clearInterval(self.timer);
                    self.timer = setInterval(function(){
                        self.queryDataResult();
                    },self.gap);
                    var netAccount=res.result.account;
                    var param = {
                            accountId:self.loginInfo.accountId,
                            loanCode:'carat',
                            authCode: res.result.accountType||netAccountType,
                            code: res.result.code,
                            netAccountNo:netAccount.split('&')[0]
                        };
                    self.commitBindAccount(param);
                }
            });
        },
        //提交认证数据
        commitBindAccount: function(param) {
            $.ajax({
                type:"post",
                url:C.Api.SUBMIT_CREDIT_AUTH,
                data:param,
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.data.resultCode) {
                        //C.Native.tip('提交成功');
                    }else {
                        //C.Native.tip('提交失败');
                    }
                },
                error: function (e) {
                        console.log(e);
                    }
            });
            C.UI.stopLoading();
        },
        //查询接口
        queryDataResult : function(){
            var self = this;
            $.ajax({
                type:"post",
                url:C.Api.GAS_STATION,
                data:{
                    accountId:self.loginInfo.accountId,
                    queryType:'carat'
                },
                success:function(res){
                    res = (typeof res === 'string') ? JSON.parse(res) : res;
                    C.UI.stopLoading();
                    if (C.Flag.SUCCESS == res.flag) {
                        var data =res.data;
                        self.custNo = data.custNo;
                        self.render(data);
                    }
                },
                error: function (e) {
                    console.log(e);
                }
            });
        }
    }));

    $(function() {
        var insurancePage = new Page();
    });
});